Package: CurricularComplexity
Type: Package
Title: Toolkit for Analyzing Curricular Complexity
Version: 1.1.0
Authors@R: c(person(given = "David", family = "Reeping", role = c("aut","cre"), email = "reepindp@ucmail.uc.edu"))
Author: David Reeping [aut, cre]
Maintainer: David Reeping <reepindp@ucmail.uc.edu>
Description: Enables educational researchers and practitioners to calculate the curricular complexity of a plan of study, visualize its prerequisite structure at scale, and conduct customizable analyses. The original tool can be found at <https://curricularanalytics.org>. Additional functions to explore curriculum complexity from the literature are also included.
Depends: R (>= 3.6.2), igraph (>= 1.2.5)
Encoding: UTF-8
License: MIT + file LICENSE
Suggests: knitr, rmarkdown
VignetteBuilder: knitr
RoxygenNote: 7.3.3
NeedsCompilation: no
Packaged: 2026-08-20 18:56:45 UTC; reepi
Repository: CRAN
Date/Publication: 2026-08-21 05:46:55 UTC

#' Calculates the core collapse sequence for a plan of study
#'
#' This function takes in a plan of study network and constructs the "core collapse sequence."
#' The core collapse sequence progressively removes courses from the plan of study with increasing
#' prereq counts and calculates the proportion of courses deleted at each step. The process stops
#' when all of the vertices have been removed. A sequence that decreases quickly to zero typically
#' indicates that the network is generally uniform with its prereqs. A sequence with more erratic
#' values that does not settle to zero smoothly would imply more dense sets of prereqs.
#' @param plan_of_study igraph object - An igraph object created using the create_plan_of_study function
#' @return List of two items: (1) sequence - the core collapse sequence, (2) the associated network for each entry
#' @export

core_collapse <- function(plan_of_study)
{
  graph_size <- vcount(plan_of_study) #find the number of vertices to use later
  core_collapse_sequence <- matrix(1,graph_size) #set up the sequence to track the k-cores
  coreness_index <- 0 #begin index
  kcore <- list()
  while (vcount(plan_of_study) > 0) #this will stop when there are no more vertices to remove
  {
    kcore[[coreness_index+1]] <- plan_of_study #save the network for reference later
    remainder <- length(as.matrix(V(plan_of_study)[degree(plan_of_study) < coreness_index+1])) #how many vertices are not members of the k+1-core?
    plan_of_study <- delete_vertices(plan_of_study,
                                     V(plan_of_study)[degree(plan_of_study) < coreness_index+1]) #remove those vertices
    core_collapse_sequence[coreness_index+1] <- remainder/graph_size #what proportion were just removed relative to the graph size?
    coreness_index <- coreness_index + 1 #next k-core
  }
  extra <- which(core_collapse_sequence == 1) #there will be some extra entries in the matrix, find those indices
  core_collapse_sequence <- core_collapse_sequence[-extra] #get rid of them
  output <- list(core_collapse_sequence,kcore) #form the output by combining the sequence and networks
  names(output) <- c("sequence","kcores")
  return(output)
}

#' Calculates the student mobility turbulence for a program
#'
#' This metric captures the volatility in student progression by analyzing
#' the withdraws and major changes, which can indicate structural barriers
#' or inefficiencies in the curriculum. This is most useful to apply to a combination
#' of programs or a unit, like a department or college. There are two coefficients,
#' withdrawn and changed major that can be used to prioritize either of the two causes
#' for turbulence. They are set to 1 and 0.5 by default, respectively.
#' @param number_withrawn numeric - the total number of students who dropped out of a program in a given unit
#' @param number_changed_major numeric - the total number of students who changed majors in a given unit
#' @param total_number_of_students numeric - the total number of students in a given unit starting at a specific time
#' @param withdrawn_coefficient numeric - a coefficient weighting the number of students who dropped out
#' @param changed_major_coefficient numeric - a coefficient weighting the number of students who changed majors out
#' @return numeric -  The student mobility turbulence
#' @export

student_mobility_turbulence <- function(number_withrawn,
                                        number_changed_major,
                                        total_number_of_students,
                                        withdrawn_coefficient = 1,
                                        changed_major_coefficient = 0.5
                                        )
{
  withdrawn <- withdrawn_coefficient * number_withrawn
  changed_major <- changed_major_coefficient * number_changed_major
  numerator <- withdrawn + changed_major
  student_mobility_turbulence_value <- numerator/total_number_of_students
  return(student_mobility_turbulence_value)
}

#' Finds the subcomplexity graph of courses beyond expected time to degree
#'
#' This function takes in a plan of study and the expected time to degree, then outputs a subcomplexity
#' graph that contains all of the courses beyond the time to degree and their prerequisites.
#' @param plan_of_study igraph object - An igraph object created using the create_plan_of_study function
#' @param expected_time_to_degree Numeric - The term where students are expected to finish (often 8)
#' @param include_coreqs Logical - Calculates the delay factor using corequisites, default value is TRUE
#' @return igraph object - the subcomplexity graph
#' @export


transfer_excess_courses <- function(plan_of_study, expected_time_to_degree, include_coreqs = TRUE)
{
  #Find the courses that extend beyond the expected time to degree.
  excess_courses <- which(vertex.attributes(plan_of_study)$term > expected_time_to_degree)

  #Check if there are courses beyond the expected time to degree, if not just return NULL.
  if (length(excess_courses) == 0)
  {
    return(NULL)
  }

  #Initialize list of graphs and matrices to store the relevant courses and requisites
  subcomplexity_graphs_of_relevant_courses <- list()
  courses_in_graph <- NULL
  reqs_in_graph <- NULL

  #We'll search through all the courses identified and make the vertex/edge matrices
  for (index in 1:length(excess_courses))
  {
    #Use the subcomplexity function to find the courses associated with the excess course
    subcomplexity_graphs_of_relevant_courses[[index]] <- subcomplexity_graph(plan_of_study, excess_courses[index])

    #Fetch all the course qualities and put them in a matrix
    course_running_list <- cbind(vertex.attributes(subcomplexity_graphs_of_relevant_courses[[index]])$name,
                                 vertex.attributes(subcomplexity_graphs_of_relevant_courses[[index]])$term,
                                 vertex.attributes(subcomplexity_graphs_of_relevant_courses[[index]])$credits,
                                 vertex.attributes(subcomplexity_graphs_of_relevant_courses[[index]])$passrate,
                                 vertex.attributes(subcomplexity_graphs_of_relevant_courses[[index]])$lostcredits,
                                 vertex.attributes(subcomplexity_graphs_of_relevant_courses[[index]])$timing
    )

    #Fetch all the requisite qualities and put them in a matrix
    reqs_running_list <- cbind(as_edgelist(subcomplexity_graphs_of_relevant_courses[[index]]),
                               edge.attributes(subcomplexity_graphs_of_relevant_courses[[index]])$reqtype)

    #Add what we found to the list of courses and requisites
    courses_in_graph <- rbind(courses_in_graph, course_running_list)
    reqs_in_graph <- rbind(reqs_in_graph, reqs_running_list)
  }

  #Now that we're done, there are certainly duplicates. Only keep unique entries.
  courses_in_graph <- unique(courses_in_graph)
  reqs_in_graph <- unique(reqs_in_graph)

  #Convert to dataframes for the igraph function and tidy them up
  courses_in_graph <- as.data.frame(courses_in_graph, stringsAsFactors = FALSE)
  reqs_in_graph <- as.data.frame(reqs_in_graph, stringsAsFactors = FALSE)
  names(courses_in_graph) <- c("name", "term", "credits", "passrate", "lostcredits", "timing")
  names(reqs_in_graph) <- c("from","to","reqtype")
  courses_in_graph$term <- as.numeric(courses_in_graph$term)
  courses_in_graph$passrate <- as.numeric(courses_in_graph$passrate)

  #For the plotting, some of the terms might be out of order and could cause overlap
  #Let's reorder them...note the order of the reqs don't matter.
  new_order <- order(courses_in_graph$term)
  courses_in_graph <- courses_in_graph[new_order,]

  #This graph will be the union of all the subcomplexity graphs for courses beyond the
  #Expected time to degree
  excess_courses_subcomplexity_graph <- graph_from_data_frame(d = reqs_in_graph,
                                                              vertices = courses_in_graph,
                                                              directed = TRUE)
  return(excess_courses_subcomplexity_graph)
}

#' Plots the plan of study with courses ordered by term
#'
#' This function takes in a plan of study and plots it in the 'plot' window.
#' The courses are ordered horizontally by term and vertically by the outdegree
#' (i.e., number of prereqs) of the vertices in that column/term. The shading of
#' the nodes corresponds to the cruciality of the course. A darker blue indicates
#' higher cruciality while white indicates lower cruciality.
#'
#' Note that there can be some overlap where a course is covering a path for a prereq,
#' which may make is seem like a course is a prereq for some other course when it is
#' in fact the course in a previous semester.
#' @param plan_of_study igraph object - An igraph object created using the create_plan_of_study function
#' @return Plots the plan of study in the 'plot' window
#' @export


plot_plan_of_study <- function(plan_of_study)
{
  #First, we'll make sure there isn't a cycle in the data that would cause an infinite loop.
  test_results <- suppressMessages(admissibility_test(plan_of_study))
  if(!is.null(test_results$DAGErrors))
  {
    warning("Your data fails the Directed Acyclic Graph admissibility test. Crucialities cannot be added to the plot. Please use *admissibility_test* to diagnose and fix the error.")
  }
  #Next, we'll calculate the course crucialities to add that detail to the plot
  if(is.null(test_results$DAGErrors))
  {
    complexity_scores <- structural_complexity(plan_of_study)
    complexity_scores <- complexity_scores$`Course Crucialities`
    crucialities <- complexity_scores$Cruciality
    #We'll append these crucialities as an attribute of the vertices.
    plan_of_study <- set_vertex_attr(plan_of_study,"cruciality",index = V(plan_of_study),crucialities)
    #Use the ramp palette to get a range of colors, we only need colors up to the highest cruciality
    colors_palette <- colorRampPalette(c("white", "dark blue"))(n=max(crucialities))
    #This will give us the right colors by evaluating the palette at the associated cruciality.
    colors_for_vertices <- colors_palette[crucialities]
    #Then we'll append the "color" attribute with those values we found.
    plan_of_study <- set_vertex_attr(plan_of_study, "color", index = V(plan_of_study), colors_for_vertices)
  }

  #To get the horizontal position, we'll use the course terms.
  terms <- as.numeric(V(plan_of_study)$term)
  horizontal_position <- terms - rep(1,length(terms)) #Shift by one to center the graph.
  vertical_position <- numeric(length(terms))

  #To get the vertical position, we'll order the courses by their outdegree.
  degrees <- degree(plan_of_study, v = V(plan_of_study), mode = "out")
  ordering <- as.data.frame(cbind(degrees,terms))
  rownames(ordering) <- 1:nrow(ordering)
  names(ordering) <- c("degree","terms")
  ordered_data <- NULL
  #This loop will organize the courses by outdegree within the context
  #of the term they are taken.
  for (index in 1:max(terms))
  {
    next_term <- ordering[ordering$terms == index,]
    next_term <- next_term[order(next_term$degree, decreasing = FALSE),]
    ordered_data <- rbind(ordered_data,next_term)
  }
  #Recover the permutation to reorder the courses by number of requisties
  #This is because "permute" wants the index the vertex should be mapped to.
  new_order <- as.numeric(rownames(ordered_data))
  id <- 1:length(new_order)
  permutation <- as.data.frame(cbind(new_order,id))
  permutation <- permutation[order(new_order,decreasing = FALSE),]
  permutation <- permutation$id
  plan_of_study <- permute(plan_of_study,permutation)

  #We'll use these counters to space out the vertices as needed.
  position <- 0

  #This loop will assign each vertex to a vertical position.
  for (index in 2:length(terms))
  {
    if((terms[index]-terms[index-1])==0)
    {
      position <- position + 2.5 #Spacing accounted for here
    }
    else
    {
      position <- 0  #Reset if we hit the next term.
    }
    vertical_position[index] <- position
  }

  #This matrix will hold the coordinates we just assigned.
  coordinates <- as.matrix(cbind(horizontal_position,vertical_position))

  #To differentiate the coreqs and prereqs, we'll make their line types and colors different
  plan_of_study <- set_edge_attr(plan_of_study, "lty", index = which(E(plan_of_study)$reqtype == "Co"), 2)
  plan_of_study <- set_edge_attr(plan_of_study, "lty", index = which(E(plan_of_study)$reqtype == "Pre"), 1)
  plan_of_study <- set_edge_attr(plan_of_study, "color", index = which(E(plan_of_study)$reqtype == "Pre"), "black")
  plan_of_study <- set_edge_attr(plan_of_study, "color", index = which(E(plan_of_study)$reqtype == "Co"), "gray 72")

  #The coreqs point directly to the course in the same term, which makes them hard to point
  #out sometimes. We'll curve the coreqs to make them easier to see.
  curved_coreqs <- c(numeric(length(E(plan_of_study))))
  curved_coreqs[which(E(plan_of_study)$reqtype == "Co")] <- 0.1

  #Rescale as needed
  xmax <- 8
  ymax <- 16
  if (max(terms) > 8)
  {
    xmax <- max(terms)
  }

  #Truncate strings that are a little too long for display purposes...
  #I'm probably missing an easier way to do this, but it works.
  list_of_courses <- names(V(plan_of_study))
  for (string in list_of_courses)
  {
    if (nchar(string) > 10)
    {
      index <- which(V(plan_of_study)$name == string)
      V(plan_of_study)$name[index] <- paste(substr(string, 1, 8),"...")
    }
  }


  #This is actual plotting function after the setup in the previous lines.

  plot.igraph(plan_of_study,layout=coordinates, vertex.shape = "circle", vertex.size = 15,
              vertex.label.cex = 0.85,
              vertex.label.color = "dark blue",
              edge.arrow.size = 0.45,
              edge.size = 0.5,
              edge.curved = curved_coreqs,
              vertex.label.dist = 10,
              vertex.label.degree = pi/2,
              rescale=FALSE,
              xlim=c(0,xmax),ylim=c(0,ymax),
              asp=0,
  )
  for (index in 1:max(terms))
  {
    text(index-1,-2,paste("Term",index), col = "gray 31")
  }
}

#' Calculates the average sequencing in a program
#'
#' This function calculates the average sequencing in the program using the
#' delay factors of the courses. The second argument, expected_time_to_degree
#' is optional. If it is not NULL, the average sequencing will be for courses
#' extending the student's time to degree. 
#' @param plan_of_study igraph object - An igraph object created using the create_plan_of_study function
#' @param expected_time_to_degree Numeric - The term where students are expected to finish (often 8)
#' @return Numeric - the average sequencing in the program
#' @export


average_sequencing <- function(plan_of_study, expected_time_to_degree = NULL)
{
  if(!is.null(expected_time_to_degree))
  {
    #First form the subcomplexity graph of the courses beyond the expected time to degree
    plan_of_study <- transfer_excess_courses(plan_of_study, expected_time_to_degree)
    relevant_courses <- which(V(plan_of_study)$term > expected_time_to_degree)
  }
  else
  {
    relevant_courses <- V(plan_of_study)
  }
  #Find the delay factors of the courses beyond the expected time-to-degree
  delay_factors <- lapply(relevant_courses,
                          function(x){
                            delay_factor(plan_of_study,x,include_coreqs = FALSE)
                          })
  delay_factors <- unlist(delay_factors) #need to unlist them from lapply
  average <- mean(delay_factors)
  return(average)
}

#' Generate a scorecard of curricular complexity metrics
#'
#' This function calculates course-level and curriculum-level curricular
#' complexity metrics for a plan of study. Course-level metrics include
#' blocking, reachability, delay, cruciality, deferment, and bottleneck
#' status. Curriculum-level metrics include structural complexity,
#' curricular rigidity, and the total number of bottleneck courses.
#'
#' @param plan_of_study An igraph object representing a plan of study,
#'   created using the \code{\link{create_plan_of_study}} function.
#' @param include_coreqs A logical value indicating whether corequisite
#'   courses should be included when calculating course-level metrics and
#'   structural complexity.
#'
#' @return A list containing two elements:
#'   \describe{
#'     \item{CourseLevel}{A data frame containing the course-level metrics
#'       \code{Course}, \code{Blocking}, \code{Reachability}, \code{Delay},
#'       \code{Cruciality}, \code{Deferment}, and \code{Bottleneck}. An
#'       asterisk in the \code{Bottleneck} column indicates that the course
#'       was identified as a bottleneck.}
#'     \item{CurriculumLevel}{A named vector containing the curriculum-level
#'       metrics \code{StructuralComplexity}, \code{CurricularRigidity}, and
#'       \code{TotalBottlenecks}.}
#'   }
#'
#' @export

generate_curricular_complexity_scorecard <- function(plan_of_study, include_coreqs = TRUE)
{
  complexity_score_card <- NULL
  curriculum_level_metrics <- NULL

  # Calculate bottlenecks once
  bottlenecks <- names(find_bottlenecks(plan_of_study))

  # Course-level metrics
  complexity_score_card <- data.frame(
    Course = names(V(plan_of_study)),
    Blocking = NA,
    Reachability = NA,
    Delay = NA,
    Cruciality = NA,
    Deferment = NA,
    Bottleneck = "",
    stringsAsFactors = FALSE
  )

  final_term <- max(V(plan_of_study)$term)

  for (course in names(V(plan_of_study)))
  {
    # Find the row corresponding to the current course
    course_index <- which(complexity_score_card$Course == course)

    complexity_score_card$Blocking[course_index] <-
      blocking_factor(plan_of_study, course, include_coreqs)

    complexity_score_card$Reachability[course_index] <-
      reachability_factor(plan_of_study, course, include_coreqs)

    complexity_score_card$Delay[course_index] <-
      delay_factor(plan_of_study, course, include_coreqs)

    complexity_score_card$Cruciality[course_index] <-
      cruciality(plan_of_study, course, include_coreqs)

    complexity_score_card$Deferment[course_index] <-
      round(
        deferment_factor(plan_of_study, course, final_term),
        2
      )

    complexity_score_card$Bottleneck[course_index] <-
      ifelse(course %in% bottlenecks, "*", "")
  }

  # Curriculum-level metrics
  structural_complexity_score <-
    structural_complexity(plan_of_study, include_coreqs)[[2]]

  curricular_rigidity_score <-
    round(curriculum_rigidity(plan_of_study), 2)

  bottlenecks_score <-
    length(bottlenecks)

  curriculum_level_metrics <- c(
    StructuralComplexity = structural_complexity_score,
    CurricularRigidity = curricular_rigidity_score,
    TotalBottlenecks = bottlenecks_score
  )

  # Return results
  results <- list(
    CourseLevel = complexity_score_card,
    CurriculumLevel = curriculum_level_metrics
  )

  return(results)
}

#' Calculates the explained complexity of courses extending time to degree
#'
#' This function takes in the subcomplexity graph from the transfer excess courses function, then finds the transfer delay
#' factor. The output is the proportion of complexity explained by courses extending time to degree.
#' @param plan_of_study igraph object - An igraph object created using the create_plan_of_study function
#' @param expected_time_to_degree Numeric - The term where students are expected to finish (often 8)
#' @param term_weighted logical - TRUE if crucialities should be term-weighted
#' @return Numeric - the explained complexity
#' @export


explained_complexity <- function(plan_of_study, expected_time_to_degree, term_weighted = FALSE)
{
  #First form the subcomplexity graph of the courses beyond the expected time to degree
  subgraph <- transfer_excess_courses(plan_of_study, expected_time_to_degree)

  #If there are no courses beyond the time to degree, then the delay factor is zero
  if (is.null(subgraph))
  {
    return(0)
  }

  #Next, we'll find the structural complexity of the transfer related courses
  #and we'll find the overall complexity.
  subcomplexity_transfer_output <- structural_complexity(subgraph, term_weighted)
  subcomplexity_full_output <- structural_complexity(plan_of_study, term_weighted)
  transfer <- subcomplexity_transfer_output$`Overall Structural Complexity`
  full <- subcomplexity_full_output$`Overall Structural Complexity`

  #To find the explained complexity, we find the ratio of the transfer subcomplexity
  #over the full complexity.
  result <- 100*transfer/full

  #We'll round the result to one decimal place
  result <- round(result, digits = 1)
  output <- list(full,transfer,result)
  names(output) <- c("Structural Complexity","Transfer Subcomplexity","Explained Complexity")

  return(output)
}

#' Calculates the delay factor of a course
#'
#' This function takes in a plan of study and a course, then finds that course's delay factor.
#' The output is the longest path of prerequisites through the given course.
#' @param plan_of_study igraph object - An igraph object created using the create_plan_of_study function
#' @param course Numeric (vertex id) or String - The course to calculate the delay factor of
#' @param include_coreqs Logical - Calculates the delay factor using corequisites, default value is TRUE
#' @return Numeric - the delay factor
#' @export


delay_factor <- function(plan_of_study, course, include_coreqs = TRUE)
{
  #First we use the subcomplexity function to sample the right courses
  necessary_courses <- subcomplexity_graph(plan_of_study, course)
  if (include_coreqs == FALSE)
  {
    necessary_courses <- delete_edges(necessary_courses, which(E(necessary_courses)$reqtype == "Co"))
  }
  #Next we call the course by name because the vertex indices were not preserved
  if (is.numeric(course)==TRUE) #Only need to covert if we're running through the loop
  {
    course <- as.character(V(plan_of_study)$name[course])
  }
  #We then use the find_X_courses functions to get a list of the courses before and after
  #the course of interest.
  blocked_courses <- find_outbound_courses(necessary_courses, course)
  previous_courses <- find_inbound_courses(necessary_courses, course)
  #Next, we need to find the longest path (prerequisite chain) through the course.
  #All simple paths gives us a list of all the paths that lead to a vertex.
  #In this case we want all paths before the course that lead to it using out degree
  #and we'll get all the courses after using the in degree instead.
  outbound <- all_simple_paths(necessary_courses, course, to = blocked_courses, mode = c("out"))
  inbound <- all_simple_paths(necessary_courses, course, to = previous_courses, mode = c("in"))

  #Next, we'll brute force the solution by checking the lengths finding the maximum paths
  #before and after the course. We'll then add their lengths.
  outbound.max <- 0   #starting with the outbound classes...
  if (length(outbound) > 0)
  {
    for (index in 1:length(outbound))
    {
      path_length <- length(outbound[[index]]) #the simple paths function uses lists, hence the [[]]
      if (path_length > outbound.max)
      {
        outbound.max <- path_length
      }
    }
  }

  inbound.max <- 0 #next we'll do the inbound courses, same process.
  if (length(inbound) > 0)
  {
    for (index in 1:length(inbound))
    {
      path_length <- length(inbound[[index]])
      if (path_length > inbound.max)
      {
        inbound.max <- path_length
      }
    }
  }

  #Next, there are some edge cases to take care of...
  #This is the typical case, there are courses before and after the course of interest.
  #Because we looked at paths before and after the course, it
  #was counted twice. Just subtract 1 from the total.
  if (outbound.max != 0 && inbound.max != 0)
  {
    longest_prereq_chain <- inbound.max + outbound.max - 1   #adjust for double count
  }
  #It's possible a course could be isolated. In that case, we take
  #the delay factor to be 1.
  else if (outbound.max == 0 && inbound.max == 0)
  {
    longest_prereq_chain <- 1
  }
  #Finally, this case accounts for a situation where either
  #the course has no prerequisites or it is the final course
  #in a chain. There's no double counting here, so we can
  #just add the path lengths.
  else
  {
    longest_prereq_chain <- inbound.max + outbound.max
  }
  return(longest_prereq_chain)
}

#' Find all possible prerequisites to a course
#'
#' This function takes in a plan of study and a course, then finds all the courses it is related to
#' through its prerequisites
#' @param plan_of_study An igraph object created using the create_plan_of_study function
#' @param course The course to find all relevant prerequisites of
#' @param include_coreqs Logical - Calculates the delay factor using corequisites, default value is TRUE
#' @return An atomic vector of vertex ids for the course's prerequisites
#' @export

find_inbound_courses <- function(plan_of_study, course, include_coreqs = TRUE)
{
  if (include_coreqs == FALSE)
  {
    plan_of_study <- delete_edges(plan_of_study, which(E(plan_of_study)$reqtype == "Co"))
  }

  #First get a vector of the courses immediately before the course of interest.
  leading_courses <- unlist(adjacent_vertices(plan_of_study, course, mode = c("in")))
  #We'll be using a while loop, so this will initialize the list of courses we'll
  #use to track the prerequisites until we run out of connections.
  previous_courses <- leading_courses
  difference <- 1 #We'll be checking if the list gets any longer after iterating
  while (difference > 0)
  {
    running_list <- NULL  #This running list will track the courses we find looking back one term.
    for (course in previous_courses)
    {
      #Get the next set of courses looking back one term.
      leading_courses <- unlist(adjacent_vertices(plan_of_study,course, mode = c("in")))
      if (length(leading_courses) > 0) #Only add something to the list if we find courses.
      {
        running_list <- c(leading_courses,running_list) #Concatenate what we found with the master list
      }
    }
    previous_run <- previous_courses #Set up the comparison by using the list of courses from the loop.
    #Duplicates are possible because of coreqs, so we'll only keep the unique courses we find.
    previous_courses <- unique(c(running_list, previous_courses))
    #This next statement will check if our master list got any bigger on the last iteration.
    difference <- abs(length(previous_run) - length(previous_courses))
  }
  return(previous_courses)
}

#' Calculates the deferment factor of a course
#'
#' This function takes in a plan of study and a course, then finds that course's deferment factor.
#' The value captures the number of terms the student can fail the course before extending their time
#' to degree.
#'
#' @param plan_of_study igraph object - An igraph object created using the create_plan_of_study function
#' @param course Numeric (vertex id) or String - The course to calculate the deferment factor of
#' @param expected_time_to_degree Numeric - The term where students are expected to finish (often 8)
#' @param outbound_only logical - TRUE (by default) if the calculation should only include courses after the course (postreqs)
#' @return Numeric - the deferment factor
#' @export


deferment_factor <- function(plan_of_study, course, expected_time_to_degree,outbound_only=TRUE)
{
  terms_before_extension <- find_number_of_free_terms(plan_of_study, course, expected_time_to_degree,outbound_only)
  deferment_factor_calculation <- 1/(1+terms_before_extension)
  return(deferment_factor_calculation)
}

#' Calculates the transfer delay factor of a course
#'
#' This function takes in the subcomplexity graph from the transfer excess courses function, then finds the transfer delay
#' factor. The output is the sum of the longest paths of prerequisites through courses related to those beyond the
#' expected time to degree.
#' @param plan_of_study igraph object - An igraph object created using the create_plan_of_study function
#' @param expected_time_to_degree Numeric - The term where students are expected to finish (often 8)
#' @return Numeric - the transfer delay factor
#' @export


transfer_delay_factor <- function(plan_of_study, expected_time_to_degree)
{
  #First form the subcomplexity graph of the courses beyond the expected time to degree
  subgraph <- transfer_excess_courses(plan_of_study, expected_time_to_degree)

  #If there are no courses beyond the time to degree, then the delay factor is zero
  if (is.null(subgraph))
  {
    return(0)
  }

  #Find the delay factors of the courses beyond the expected time-to-degree
  relevant_courses <- which(V(subgraph)$term > expected_time_to_degree)
  delay_factors <- lapply(relevant_courses,
         function(x){
           delay_factor(subgraph,x)
           }
         )
  delay_factors <- unlist(delay_factors) #need to unlist them from lapply
  delay_factor_transfer <- sum(delay_factors)

  return(delay_factor_transfer)
}

#' Calculate Topic Cruciality
#'
#' Calculates the cruciality attributable to a particular course-code stem
#' within a plan of study. Topic cruciality is calculated as the sum of the
#' cruciality values for all courses in the plan of study whose course code
#' matches the specified course-code stem.
#'
#' This measure is generalized from the concept of math cruciality described
#' by Ryan (2026), which examines the contribution of required mathematics
#' courses to curriculum complexity. Rather than being restricted to
#' mathematics, this function can be used to calculate the cruciality of any
#' collection of courses that can be identified by a common course-code stem.
#'
#' @param plan_of_study A plan of study for which course crucialities can be
#'   calculated.
#' @param course_code_stem A character string identifying the course-code stem
#'   used to define the topic area. For example, `"MATH"` identifies all
#'   mathematics courses with the `"MATH"` course-code stem.
#' @param include_coreqs A logical value indicating whether corequisite
#' relationships should be included when calculating course crucialities.
#' Defaults to TRUE.
#'
#' @return The topic cruciality, calculated as the sum of the cruciality values
#'   for courses in the plan of study with the specified course-code stem.
#'
#' @references
#' Ryan, O. J. (2026). *The Role of Math Courses in Engineering Education:
#' Examining How Math Courses Shape First-Year Student Transition, Curriculum
#' Complexity, and Time-to-Degree* (Doctoral dissertation, Virginia Tech).
#' https://vtechworks.lib.vt.edu/items/4ddd7b33-8700-45d4-988d-2111a2970389


topic_cruciality <- function(plan_of_study, course_code_stem, include_coreqs = TRUE)
{
  crucialities <- structural_complexity(plan_of_study = plan_of_study, include_coreqs = include_coreqs)[[1]]$Cruciality
  all_courses <- V(plan_of_study)$name
  relevant_courses_index <- grepl(course_code_stem,all_courses)
  relevant_crucialities <- crucialities[relevant_courses_index]
  result <- sum(relevant_crucialities)
  return(result)
}

#' Find all possible courses that depend on a particular course
#'
#' This function takes in a plan of study and a course, then finds all the courses it is related to
#' through its prerequisites (after the course).
#' @param plan_of_study An igraph object created using the create_plan_of_study function
#' @param course The course to find all relevant courses that directly or indirectly have it as a prereq
#' @param include_coreqs Logical - Calculates the delay factor using corequisites, default value is TRUE
#' @return An atomic vector of vertex ids for the course's following courses
#' @export


find_outbound_courses <- function(plan_of_study, course, include_coreqs = TRUE)
{
  if (include_coreqs == FALSE)
  {
    plan_of_study <- delete_edges(plan_of_study, which(E(plan_of_study)$reqtype == "Co"))
  }

  #The first statement looks ahead to see what courses are immediately after
  #the one we're interested in.
  next_courses <- unlist(adjacent_vertices(plan_of_study, course, mode = c("out")))
  #We'll be using a while loop, so this will initialize the list of courses we'll
  #use to track the following courses that are blocked until we run out of connections.
  blocked_courses <- next_courses
  while (length(next_courses) > 0)  #We'll keep going until there are no more courses found.
  {
    running_list <- NULL #This running list will track the courses we find looking forward one term.
    for (course in next_courses)  #This for loop will iterate through each set of courses we find.
    {
      #Get the next set of courses looking forward one term.
      following_courses <- unlist(adjacent_vertices(plan_of_study,course, mode = c("out")))
      if (length(following_courses) > 0)  #Only add something to the list if we find courses.
      {
        running_list <- c(following_courses,running_list) #add the courses to our master list
        next_courses <- following_courses #we'll check these courses next
      }
    }
    blocked_courses <- unique(c(running_list, blocked_courses)) #only keep the unique courses
    next_courses <- running_list #see if we have any new courses to check.
  }
  return(blocked_courses)
}

#' Convert requisites to original notation
#'
#' This function takes in either the pre or corequisites of a plan of study as a vector, then
#' removes any additional information like OR relationships and minimum grades such that the
#' network can be analyzed using the traditional functions.
#' @param requisites vector object - A vector describing the pre and corequisites (as strings)
#' @return vector object -  A simplified vector describing the pre and corequisites (as strings)
#' @export

simplify_requisites <- function(requisites) {
  #Replace all ORs (+) with ANDs (,)
  requisites <- gsub("\\+", ",",requisites)
  #Remove the parentheses
  requisites <- gsub("[()]", "", requisites)
  #Begins removing the notation for MINGRADE and FROM.
  requisites <- gsub("FROM|MINGRADE", "", requisites)
  #Remove notation for MINGRADE and FROM.
  requisites <- gsub("\\[.*?\\]", "", requisites)
  #Return the courses with the original notation.
  return(requisites)
}

#' Finds the number of terms a course can move to
#'
#' This function takes in a plan of study, a course, the expected time to degree, and a
#' logical value indicating whether to restrict the number of free terms to those later
#' in the curriculum. The value is the number of free terms that the course can move to
#' @param plan_of_study igraph object - An igraph object created using the create_plan_of_study function
#' @param course Numeric (vertex id) or String - The course to find the number of free terms for
#' @param expected_time_to_degree Numeric - The term where students are expected to finish (often 8)
#' @param outbound_only logical - TRUE if the calculation should only include courses after the course (postreqs)
#' @return Numeric - the number of free terms
#' @export

find_number_of_free_terms <- function(plan_of_study,
                                      course, 
                                      expected_time_to_degree,
                                      outbound_only)
{
  course_term <- V(plan_of_study)[course]$term
  prereqs <- find_inbound_courses(plan_of_study,course,include_coreqs = FALSE)
  prereqs_terms <- V(plan_of_study)[prereqs]$term
  postreqs <- find_outbound_courses(plan_of_study,course, include_coreqs = FALSE)
  postreqs_terms <- V(plan_of_study)[postreqs]$term
  terms_with_courses <- unique(c(course_term,prereqs_terms,postreqs_terms))
  terms_with_courses <- terms_with_courses[order(terms_with_courses)]
  term_list <- 1:expected_time_to_degree
  prereq_gaps <- term_list %in% terms_with_courses
  
  index <- expected_time_to_degree
  number_of_free_terms <- 0
  
  if (outbound_only == TRUE)
  {
    while (index >= course_term)
    {
      if(prereq_gaps[index] == FALSE)
      {
        number_of_free_terms <- number_of_free_terms + 1
      }
      index <- index - 1
    }
  }
  else
  {
    course_delay_factor <- delay_factor(plan_of_study,course)
    number_of_free_terms <- expected_time_to_degree - course_delay_factor
  }
  return(number_of_free_terms)
}

#' Calculates the cruciality of a course
#'
#' This function takes in a plan of study and a course, then finds that course's cruciality.
#' The value is the sum of the blocking and delay factors of the course
#' @param plan_of_study igraph object - An igraph object created using the create_plan_of_study function
#' @param course Numeric (vertex id) or String - The course to calculate the cruciality of
#' @param include_coreqs logical - Indicates whether corequisites should be included in the calculation
#' @return Numeric - the course's cruciality
#' @export


cruciality <- function(plan_of_study, course, include_coreqs = TRUE)
{
  cruciality_value <- blocking_factor(plan_of_study,course,include_coreqs) + delay_factor(plan_of_study,course,include_coreqs)
  return(cruciality_value)
}

#' Calculates the curriculum rigidity
#'
#' This function takes in a plan of study and then finds the curriculum's rigidity.
#' The rigidity is the beta index of the graph, which is the number of prerequisites
#' divided by the number of courses
#' @param plan_of_study igraph object - An igraph object created using the create_plan_of_study function
#' @return Numeric - the curriculum rigidity
#' @export

curriculum_rigidity <- function(plan_of_study)
{
  E <- length(E(plan_of_study))
  V <- length(V(plan_of_study))
  rigidity <- E/V
  return(rigidity)
}

#' Create a plan of study igraph object
#'
#' This function takes in a set of courses, their terms, prerequisites, and corequisites.
#' Optional arguments include the number of credits, pass rates, lost credits from transferring,
#' and the frequency of course offerings. The function creates an igraph structure of edges and nodes with the
#' given qualities.
#'
#' It is recommended that the user imports the data from a csv file to
#' ensure the indices for each atomic vector correspond to the attributes of one course.
#'
#' @param Course atomic vector - strings for each course
#' @param Term a numeric atomic vector - the term  each course is offered
#' @param Prereq atomic vector - strings of the courses' prereqs, separated by commas
#' @param Coreq atomic vector - strings of the courses' coreqs, separated by commas
#' @param Credits numeric atomic vector - number of credits each course is worth (optional)
#' @param LostCredits numeric atomic vector - (for transfer students) identifies if credit for the course is not applied toward a student's degree, 1. If it is, 0. (optional)
#' @param PassRate numeric atomic vector - pass rates by class (optional)
#' @param Timing numeric atomic vector - number of times the course is offered in 2 years (optional)
#' @param Institution atomic vector - strings of course affiliations (CC or FY)
#' @return An igraph object of the prerequisite structure
#' @export

create_plan_of_study <- function(Course,
                                 Term,
                                 Prereq,
                                 Coreq,
                                 Credits = NULL,
                                 LostCredits = NULL,
                                 PassRate = NULL,
                                 Timing = NULL,
                                 Institution = NULL
                                 )
{

   #These statements handle optional arguments if they're unused.
  if (is.null(PassRate))
  {
    PassRate <- rep(NA, length(Course))
  }
  if (is.null(Credits))
  {
    Credits <- rep(NA, length(Course))
  }
  if (is.null(LostCredits))
  {
    LostCredits <- rep(0, length(Course))
  }
  if (is.null(Timing))
  {
    Timing <- rep("All", length(Course))
  }
  if (is.null(Institution))
  {
    Institution <- rep("FY", length(Course))
  }

  #Avoiding "data too long" error by replacing white space cells with NA
  Prereq[Prereq == ""] <- NA
  Coreq[Coreq == ""] <- NA
  LostCredits[LostCredits == ""] <- NA
  PassRate[PassRate == ""] <- NA
  Timing[Timing == ""] <- "All"
  Institution[Institution == ""] <- "FY"

  ###End of data prep stage###

  #The actual function starts here.
  courses <- as.data.frame(cbind(Course, Term, Credits, PassRate, LostCredits,Timing,Institution), stringsAsFactors = FALSE)  #create vertex matrix
  courses$Term <- as.numeric(courses$Term)
  courses$LostCredits <- as.numeric(courses$LostCredits)
  courses$PassRate <- as.numeric(courses$PassRate)
  names(courses) <- c("name", "term", "credits", "passrate", "lostcredits","timing","institution")
  courses$name <- trimws(courses$name) #trims any whitespace...wasted too much time debugging to find out this was an issue.
  courses$name <- make.unique(courses$name, sep = " ") #if there are duplicates like "gen ed course," this function will make each vertex unique

  reqs <- NULL  #initialize the requisties
  prereqs_subset <- Prereq[is.na(Prereq) == FALSE] #take all the prereqs and put them into a data frame
  prereq_index <- which(is.na(Prereq) == FALSE)
  if (length(prereqs_subset) > 0)
  {
  for (courseindex in 1:length(prereqs_subset))
  {
    course_to_fetch <- prereq_index[courseindex] #what is the course for this prereq?
    course_prereqs <- unlist(strsplit(prereqs_subset[courseindex], split = ",")) #split the prereqs into a vector
    course_prereqs <- trimws(course_prereqs) #trims any whitespace...
    course <- matrix(Course[course_to_fetch], nrow = length(course_prereqs)) #initialize the matrix to store these edges
    req_type <- matrix("Pre", nrow = length(course_prereqs)) #Save the type of requistie
    edges_for_course <- cbind(course_prereqs,course, req_type) #Record the prereqs
    reqs <- rbind(reqs,edges_for_course) #Combine them with the ongoing list
    names(reqs) <- c("from","to")

  }
  }
  coreqs_subset <- Coreq[is.na(Coreq) == FALSE]  #Same process for coreqs
  coreq_index <- which(is.na(Coreq) == FALSE)
  if(length(coreqs_subset) > 0)
  {
  for (courseindex in 1:length(coreqs_subset))
  {
    course_to_fetch <- coreq_index[courseindex] #what is the course for this coreq?
    course_coreqs <- unlist(strsplit(coreqs_subset[courseindex], split = ","))
    course_coreqs <- trimws(course_coreqs) #trims any whitespace...
    course <- matrix(Course[course_to_fetch], nrow = length(course_coreqs))
    req_type <- matrix("Co", nrow = length(course_coreqs))
    edges_for_course <- cbind(course_coreqs, course, req_type)
    reqs <- rbind(reqs,edges_for_course)
  }
  }
  if (is.null(reqs) == FALSE)
  {
  reqs <- as.data.frame(reqs,stringsAsFactors = FALSE)
  names(reqs) <- c("from","to","reqtype")

  #Remove degenerate prereqs that don't appear in course list
  list_of_reqs <- as.character(unique(unlist(reqs[,1:2])))
  for (index in list_of_reqs)
  {
   if (is.element(index,courses$name) == FALSE)
   {
     req_to_remove <- which(reqs == index, arr.ind = TRUE)[,1]
     reqs <- reqs[-req_to_remove,]
   }
  }
  }

  #Create the plan of study object...
  plan_of_study <- graph_from_data_frame(d = reqs, vertices = courses, directed = TRUE) #Create the graph from the requisites and courses, saving the attributes
  return(plan_of_study)
}

#' Creates a subcomplexity graph for a course
#'
#' This function takes in a plan of study and course, then constructs the subcomplexity graph for the course.
#' @param plan_of_study igraph object - An igraph object created using the create_plan_of_study function
#' @param course Numeric (vertex id) or String - The course to find the subcomplexity graph of
#' @return igraph object representing the course's subcomplexity graph.
#' @export


subcomplexity_graph <- function(plan_of_study, course)
{
  #To get the subcomplexity graph for a course, we need to get all the courses in its
  #prerequisite chain. We'll use the find_X_courses functions to get those vertices
  blocked_courses <- find_outbound_courses(plan_of_study, course)
  previous_courses <- find_inbound_courses(plan_of_study, course)
  #Next, we'll put all those vertices in one set. We'll add in the course of interest
  #by pulling its index and appending it to the set.
  relevant_courses <- c(blocked_courses,previous_courses,as.numeric(V(plan_of_study)[course]))
  #This igraph function will make a subgraph based on the vertices we specified.
  reduced_graph <- induced_subgraph(plan_of_study,relevant_courses)
  return(reduced_graph)
}

#' Calculates the reachability factor of a course
#'
#' This function takes in a plan of study and a course, then finds that course's reachability factor.
#' The value is the number of courses needed to be passed before enrolling in the given course.
#' @param plan_of_study igraph object - An igraph object created using the create_plan_of_study function
#' @param course Numeric (vertex id) or String - The course to calculate the blocking factor of
#' @param include_coreqs logical - Indicates whether corequisites should be included in the calculation
#' @return Numeric - the reachability factor
#' @export


reachability_factor <- function(plan_of_study, course, include_coreqs = TRUE)
{
  if (include_coreqs == FALSE)
  {
    plan_of_study <- delete_edges(plan_of_study, which(E(plan_of_study)$reqtype == "Co"))
  }
  #We can simply call the find_outbound_courses function and find the number of
  #courses after the course of interest. This gives us the desired result.
  leading_courses <- find_inbound_courses(plan_of_study, course)
  number_leading <- length(leading_courses)
  return(number_leading)
}

#' Calculates inflexibility factor of a plan of study
#'
#'Calculates the inflexibility factor for courses that have specific offering times extending chains beyond the
#'expected time to degree.
#' @param plan_of_study igraph object - An igraph object created using the create_plan_of_study function
#' @param time_to_degree numeric - expected time to degree, often 8
#' @return list of (1) a dataframe of inflexibility factors and (2) a total inflexibility factor
#' @export

inflexibility_factor <- function(plan_of_study, time_to_degree)
{
  #First, we'll figure out which courses we need to check for limited offerings
  num_of_courses <- length(V(plan_of_study))
  courses_to_check <- which(V(plan_of_study)$timing != "All")
  #We'll initialize the list of inflexibility factor.
  inflexibility_factors <- rep(0,num_of_courses)
  #Next, we'll iterate through the list, checking each course one-by-one
  for (course in courses_to_check)
  {
    #We'll first fetch all of the courses that are connected to the given course through
    #a prerequisite or corequisite relationship. Then, we'll get the terms they reside in.
    outbound_courses <- find_outbound_courses(plan_of_study, course)
    terms_to_check <- V(plan_of_study)$term[c(course,outbound_courses)]

    #The next step will be to determine the term adjustment. If the timing is Fall or Spring, then the
    #adjustment is 2 terms, otherwise it is assumed the timing is alternating Fall or Spring, meaning
    #the adjustment is 4 terms.
    if(V(plan_of_study)$timing[course] == "Fall" |
       V(plan_of_study)$timing[course] == "Spring")
    {
      term_adjustment <- 2
    }
    else if (V(plan_of_study)$timing[course] == "Alt Fall" |
             V(plan_of_study)$timing[course] == "Alt Spring")
    {
      term_adjustment <- 4
    }

    #We'll add the resulting term adjustment to the terms of the outbound
    #courses, then check which ones ended up going beyond the expected
    #time to degree.
    terms_to_check <- terms_to_check + term_adjustment
    courses_beyond_ttd <- which(terms_to_check > time_to_degree)
    terms_to_check <- terms_to_check[courses_beyond_ttd]

    #To determine the weighting, we need the course term, the term adjustment
    #and if the adjustment caused courses to extend beyond the specified time
    #to degree.
    course_term <- V(plan_of_study)$term[course]
    if(length(terms_to_check) > 0)
    {
      #The weighting is the sum of the number of terms beyond the time to degree
      #the course term, and the term adjustment.
      weighting <- (max(terms_to_check)-time_to_degree) + course_term + term_adjustment
    }
    else
    {
      #If none of the courses extended beyond the expected time to degree, we'll just
      #use the course term and term adjustment.
      weighting <- course_term + term_adjustment
    }

    #We multiply the resulting weight with the delay factor.
    course_delay_factor <- delay_factor(plan_of_study,course)
    inflexibility_factors[course] <- weighting*course_delay_factor

  }

  #In the end, we'll add all of the inflexibility factors together.
  total_inflexibility_factor <- sum(inflexibility_factors)

  #And to make the output nice, we'll get the course names and bind them
  #with the vector of inflexibility factors.
  course_names <- V(plan_of_study)$name
  output_table <- cbind(course_names,inflexibility_factors)
  output_table <- as.data.frame(output_table)
  output_table$course_names <- as.character(output_table$course_names)
  output_table$inflexibility_factors <- as.numeric(as.character(output_table$inflexibility_factors))
  output <- list(output_table,total_inflexibility_factor)
  names(output) <- c("Inflexibility Factors","Total")

  return(output)
}

#' Calculates structural complexity of a plan of study
#'
#' This function takes in a plan of study, then finds the plan of study's structural complexity.
#' @param plan_of_study igraph object - An igraph object created using the create_plan_of_study function
#' @param term_weighted logical - TRUE if crucialities should be term-weighted
#' @param include_coreqs logical - TRUE if coreqs should be included when calculating blocking and delay factor
#' @param quarters logical - TRUE if the plan of study uses quarters instead of semesters
#' @return list of (1) a dataframe of course crucialities, delay factors, and blocking factors; (2) a numeric value
#' of structural complexity
#' @export

structural_complexity <- function(plan_of_study, term_weighted = FALSE, include_coreqs = TRUE, quarters = FALSE)
{
  if (include_coreqs == FALSE)
  {
    plan_of_study <- delete_edges(plan_of_study, which(E(plan_of_study)$reqtype == "Co"))
  }
  #Set up the matrix to track all the structural complexity elements.
  structural_complexity_scores <- as.data.frame(matrix(NA,nrow = length(V(plan_of_study)), ncol = 4))
  names(structural_complexity_scores) <- c("Course","Blocking","Delay", "Cruciality")
  structural_complexity_scores$Course <- V(plan_of_study)$name
  #Iterate through all the courses and calculating the indices we need.
  for (index in 1:length(V(plan_of_study)))
  {
    structural_complexity_scores$Blocking[index] <- blocking_factor(plan_of_study, index)
    structural_complexity_scores$Delay[index] <- delay_factor(plan_of_study, index)
    structural_complexity_scores$Cruciality[index] <- structural_complexity_scores$Blocking[index] + structural_complexity_scores$Delay[index]
  }

  if(term_weighted == TRUE)
  {
    terms <- V(plan_of_study)$term
    structural_complexity_scores$Blocking <- structural_complexity_scores$Blocking*terms
    structural_complexity_scores$Delay <- structural_complexity_scores$Delay*terms
    structural_complexity_scores$Cruciality <- structural_complexity_scores$Cruciality*terms
  }
  
  if(quarters == TRUE)
  {
    structural_complexity_scores$Blocking <- round(structural_complexity_scores$Blocking/1.5,2)
    structural_complexity_scores$Delay <- round(structural_complexity_scores$Delay/1.5,2)
    structural_complexity_scores$Cruciality <- round(structural_complexity_scores$Cruciality/1.5,2)
  }

  #The overall structural complexity is the sum of the individual crucialities
  overall_complexity <- sum(structural_complexity_scores$Cruciality)
  #We'll output the summary score and details in a list.
  output <- list(structural_complexity_scores,overall_complexity)
  names(output) <- c("Course Crucialities","Overall Structural Complexity")
  return(output)
}

#' Finds the bottlenecks in the plan of study based on prerequisite relationships
#'
#' This function takes in a plan of study and three parameters. In this case, we
#' choose min_prereq,min_postreq, and min_connections. The value of min_prereq is the minimum number of prerequisites defining
#' a bottleneck (in the user's perspective), whereas min_postreq is the minimum number of courses
#' the given course is a prerequisite for. Finally, min_connections is the minimum total of the number of prerequisites
#' and the number of courses the given course is a prerequisite for. A course is a bottleneck if it meets
#' at least one of the parameters
#'
#' Suggested values for typical usage is find_bottleneck(x,3,3,5), which are #' provided by default.
#' Note that min_connections >= min_prereq + min_postreq - 2. If this is violated, a warning is
#' provided and corrected to the suggested minimum value of min_prereq + min_postreq - 2.
#'
#' The output is an atomic vector of possible bottlenecks based on the user-defined parameters.
#'
#' @param plan_of_study igraph object - An igraph object created using the create_plan_of_study function
#' @param min_prereq numeric - minimum number of prerequisites defining a bottleneck
#' @param min_postreq numeric - minimum number of courses the given course is a prerequisite for
#' @param min_connections numeric - minimum total of the number of prerequisites
#' @param include_coreqs boolean - default is TRUE, treats corequisites as prerequisites
#' and the number of courses the given course is a prerequisite for
#' @return atomic vector - list of courses meeting at least one condition of the three parameters
#' @export

find_bottlenecks <- function(plan_of_study, min_prereq = 3, min_postreq = 3, min_connections = 5,include_coreqs = TRUE)
{
  #First we'll initialize a vector of the bottlenecks and get the IDs of the courses to process.
  bottleneck_list <- NULL
  courses_to_process <- V(plan_of_study)
  #If we want to exclude the coreqs, we'll find each of the edges with reqtype of "Co" and delete
  #them from the network before calculating the various in-, out-, and total degrees of each node.
  if (include_coreqs == FALSE)
  {
    coreqs_to_delete <- which(E(plan_of_study)$reqtype == "Co")
    plan_of_study <- delete.edges(plan_of_study, coreqs_to_delete)
  }
  #We'll check if the last parameter is an appropriate value
  minimum_value_for_min_connections <- min_prereq + min_postreq - 2
  #If not, we'll throw a warning and adjust to the minimum sensible value.
  if (min_connections <= minimum_value_for_min_connections)
  {
    min_connections <- minimum_value_for_min_connections
    warning(paste("Your value for min_connections was too low. It has been adjusted to ", min_connections,".", sep = ""))
  }
  #We'll iterate through each course and calculate the in-, out-, and total degrees of each vertex.
  for (course in courses_to_process)
  {
    num_prereqs <- degree(plan_of_study,
                                v = courses_to_process[course],
                                mode = "in"
                                )
    num_postreqs <- degree(plan_of_study,
                                v = courses_to_process[course],
                                mode = "out"
    )
    num_connections <- degree(plan_of_study,
                           v = courses_to_process[course],
                           mode = "total"
    )
    #Getting rid of the named number attribute that is an artifact of the "degree" function.
    num_prereqs <- as.numeric(num_prereqs)
    num_postreqs <- as.numeric(num_postreqs)
    num_connections <- as.numeric(num_connections)
    #We'll check if any of the conditions are violated.
    if(num_prereqs >= min_prereq | num_postreqs >= min_postreq | num_connections >= min_connections)
    {
      #If so, we add the course ID to the list.
      bottleneck_to_add <- course
      bottleneck_list <- c(bottleneck_list,bottleneck_to_add)
    }
  }
  #Finally, we'll get the names of each course using the V function from igraph to get the vertex
  #list. The result is what we'll return.
  bottleneck_list <- V(plan_of_study)[bottleneck_list]
  return(bottleneck_list)
}

#' Automatically check for data entry issues
#'
#' This function takes in a plan of study, then checks for potential data entry issues.
#' It will detect issues in formatting with the csv (such as notes creating empty rows), if there
#' are cycles in the network, and if pre- and corequisites are appropriately defined.
#' @param plan_of_study igraph object - An igraph object created using the create_plan_of_study function
#' @return List of errors to correct for cycles, prereqs, and coreqs
#' @export

admissibility_test <- function(plan_of_study)
{
  errors <- 0
  itemstocheck <- list( DAGErrors = NULL, PrereqErrors = NULL, CoreqErrors = NULL )
  #Check for formatting issues
  if(any(V(plan_of_study)$name == "") | any(is.na(V(plan_of_study)$name)))
  {
    errors <- errors + 1
    message("(Formatting Error): Your csv appears to have data in a row where no course is defined. Check the bottom rows of the csv and delete/move their contents if they are notes. Highlight the bottom rows and select 'Clear All' in Excel.")
    cat("\n")
  }

  #Check if plan of study is a directed acyclic graph
  dag_test <- is_dag(plan_of_study)
  if(dag_test == FALSE)
  {
    errors <- errors + 1
    message("(Not Directed Acyclic Graph): Your plan of study did not pass an admissibility test. One or more of your prerequisites/corequisites form a cycle. Check if courses are mutually coreqed. If so, check the original plan of study for the correct direction.")
    cat("\n")
    #Get the relevant courses...
    edgelist <- as_edgelist(plan_of_study)

    cycles <- NULL
    c_index <- 1
    for (index in 1:nrow(edgelist))
    {
      possible_cycle <- c(edgelist[index,2],edgelist[index,1])
      id <- which(edgelist[,1] == possible_cycle[1] & edgelist[,2] == possible_cycle[2])
      if(length(id)>0)
      {
        cycles[[c_index]] <- c(edgelist[id,1],edgelist[id,2])
        c_index <- c_index+1
      }
    }
    itemstocheck[["DAGErrors"]] <- unique(unlist(cycles))
  }

  test<-as.data.frame(cbind(as_edgelist(plan_of_study),E(plan_of_study)$reqtype), stringsAsFactors = FALSE)
  name_term_dictionary <- as.data.frame(cbind(V(plan_of_study)$name,
                                              V(plan_of_study)$term),
                                        stringsAsFactors = FALSE)
  test_numbered <- test
  for(x in name_term_dictionary$V1)
  {
    from_index <- which(test$V1 == x)
    to_index <- which(test$V2 == x)
    test_numbered$V1[from_index] <- name_term_dictionary$V2[which(name_term_dictionary$V1 == x)]
    test_numbered$V2[to_index] <- name_term_dictionary$V2[which(name_term_dictionary$V1 == x)]
  }

  prereqs <- which(test_numbered$V3 == "Pre")
  uncoreqs <- test[-prereqs,]
  unprereqs <- test[prereqs,]

  coreqs <- test_numbered[-prereqs,]
  prereqs <- test_numbered[prereqs,]

  same_term_test <- NULL
  different_term_test <- NULL

  for(x in 1:nrow(prereqs))
  {
    same_term_test[x] <- prereqs$V1[x] == prereqs$V2[x]
  }
  prereqstocheck <- unprereqs[which(same_term_test == TRUE),]
  for(x in 1:nrow(coreqs))
  {
    different_term_test[x] <- coreqs$V1[x] != coreqs$V2[x]
  }
  coreqstocheck <- uncoreqs[which(different_term_test == TRUE),]

  if(!is.null(prereqstocheck) && nrow(prereqstocheck) > 0)
  {
    errors <- errors + 1
    message("(Illogical Prereqs): One or more courses have a prereq in the same semester as themselves.")
    cat("\n")
    itemstocheck[["PrereqErrors"]] <- unique(unlist(prereqstocheck[, c(1,2), drop = FALSE]))
  }
  if(!is.null(coreqstocheck) && nrow(coreqstocheck) > 0)
  {
    errors <- errors + 1
    message("(Illogical Coreqs): One or more courses that serve as coreqs are in different semesters.")
    cat("\n")
    itemstocheck[["CoreqErrors"]] <- unique(unlist(coreqstocheck[, c(1,2), drop = FALSE]))
  }
  # if (errors == 0)
  # {
  #   itemstocheck <- "No structural or formatting errors found."
  # }
  return(itemstocheck)
}

---
title: "CurricularComplexity Demo"
author: "David Reeping"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{CurricularComplexity Demo}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

The notebook documents how to use the Curricular Complexity package to analyze different plans of study across disciplines. Using the ideas put forth by Heileman et al. (2018) to conceptualize "Curricular Analytics" and 
related efforts to systematically evaluate the accessibility or complexity of different programs in the literature, we present a comprehensive set of functions to look at curricula from several angles. 

# 1. Data Requirements
To get started, we need to discuss what kind of data is needed to run the basic
analyses in the package. The main premise of Curricular Analytics, and similar
complementary methods, is to treat a program or curriculum as a graph (or network). 
In this model, we treat each course as a vertex (or node) in the network. 
The edges, or connections among the vertices, are the prerequisites 
and corequisites defining the sequence in which courses must be completed. For
example, the data would be entered like so.

```{r}
courses <-       c("A","B","C","D","E","F","G","H","I")
prerequisites <- c(" "," "," ","A","C"," ","D","F","D")
corequisites <-  c(" ","A"," "," "," "," "," "," ","H")
```

Note that the entry for "A," or the first index of the vector, is intended to
be associated with the corresponding first index of the two other vectors: 
prerequisites and corequisites. Typically, this would be entered in a spreadsheet
where each row corresponds to a course and its relevant information. 

Believe it or not, these data are sufficient to perform the standard analyses in 
Curricular Analytics. However, it is useful to include some additional information
to the network to make it correspond to actual curricula. Specifically, we 
want to specify the term in which each of these courses are taken. So, we can
introduce a vector that gives each course a term.

```{r}
terms <- c(1,1,1,2,2,2,3,3,3)
```

To run the analyses in the package, we need to create an object that
works with the functionality of the igraph package - which enables much of
the analysis. Now, we'll load our package to get access to the functions we need.

```{r message=FALSE, warning=FALSE}
library(CurricularComplexity)
```

The function that will create what we call the *plan of study object* is called
*create_plan_of_study*. It will take four inputs at minimum, the courses, the 
prerequisites, the corequisites, and the terms. There are several optional 
arguments we will attend to later.

```{r}
example_plan_of_study <- create_plan_of_study(Course = courses,
                                              Prereq = prerequisites,
                                              Coreq = corequisites,
                                              Term = terms)
```

To plot this plan of study, we use the *plot_plan_of_study* function. The 
only input is the object we just created.

```{r}
plot_plan_of_study(example_plan_of_study)
```

When we model curricula as networks in this way, we should always get what is 
called a "directed acyclic graph." 

*Directed*: Meaning that the order in which you move from vertex to vertex matters
*Acyclic*: Meaning that you CANNOT revisit a vertex; there are no "cycles" or loops

These properties naturally emerge from our understanding of how academic 
programs work. Prerequisites define the order in which courses can be completed,
which suggests that movement from one vertex to another has a direction.
Moreover, because the program defines the sequencing of courses, students are
not expected to go back and retake courses (though this does happen, we are
not handling student data, only the program information). Therefore, there 
should be no loops - satisfying the acyclic criterion.

There are occasional exceptions that have appeared during our analyses of
engineering programs in the US, particularly how laboratory courses are connected
to their lecture counterparts. In these cases, the program author will sometimes 
list the lecture course as a corequisite for the laboratory course AND the
laboratory course as a corequisite for the lecture course. This issue is referred
to as courses being *mutually coreqed*. This configuration creates a cycle and 
thereby violates the acyclic criterion. This situation may not seem like a 
pertinent issue, but the presence of a cycle renders some functions usable. 

Whenever you have courses that are mutually coreqed you *must* select one 
direction to define the corequisite relationship. In the case of laboratory 
courses, we recommend that the corequisite relationship be defined in the
row of the laboratory course. If you are running several programs, be consistent
in the chosen direction.

To check whether your data is ready for analysis, you can use the following 
function called *admissibility test*. This function checks for cases where
there are illogical arrangements of courses (e.g., a course and its prereq
occurring in the same semester) and cycles present. The only input is the
plan of study object we created. If there are issues, the function will
point you to which courses are causing the problem(s).

```{r}
admissibility_test(example_plan_of_study)
```

What if there are issues? Let's mess up the plan of study data. We'll introduce three common errors. First, we'll make A and B corequisites with one another - which introduces a cycle, a problematic feature of these graphs we'll discuss later when we're calculating different quantities. We'll make E a prerequisite for F and have I and H be corequisites, both of which are illogical combinations. The admissibility test will flash us messages of any relevant errors and give a vector of the problematic courses. 

```{r}
courses <-       c("A","B","C","D","E","F","G","H","I")
prerequisites <- c(" "," "," ","A","C","E","D","F","D") 
corequisites <-  c("B","A"," "," "," ","I"," "," ","H") 
#E is a prereq for F in same semester
#A and B are mutually coreqed, F has coreq I in diff semesters

error_plan_of_study <- create_plan_of_study(Course = courses,
                                              Prereq = prerequisites,
                                              Coreq = corequisites,
                                              Term = terms)

admissibility_test(error_plan_of_study)
```

Note that the plotting functionality depends on the graph being a DAG, so if that test is failed, you will be given a warning message to fix it. However, the plan of study will still be plotted. 

```{r}
plot_plan_of_study(error_plan_of_study)
```

## 1.1 Representing more complex prerequisite relationships
In the original conceptualization of Curricular Analytics, data entry can only handle AND type relationships with pre and corequisites. For those that want to incorporate more detailed prerequisite relationships, we offer the following notation to make data entry more straightforward. Moreover, future metrics could take advantage of this additional information.

*AND-type relationships*

For AND type relationships, meaning the student must pass both A, B, *and* C. We use commas to separate them: A, B, C.

*OR-type relationships*

For OR type relationships, meaning the student must pass both A, B, *or* C. We use plus signs to separate them: A + B + C.

*Subset of courses*

When students are provided a list of courses from which they are required to pass some subset of them, we can use the *FROM* keyword in the following fashion. So, for example, if the list of courses is A, B, C, D, E and students must complete two of them, then we would write: FROM(A,B,C,D,E)[2]. In general, for X courses that must be completed, the notation is FROM(A,B,C,D,...,Z)[X].

*Minimum grade*

If a course must be completed with a minimum grade before enrolling in a later course, we use the keyword *MINGRADE*. For example, if A must be completed with at least a C-, then we would write: MINGRADE(A)[C-]. In general, if A must be completed with grade X, we notation is MINGRADE(A)[X].

*Combining different types of requirements*

Sometimes you might need to combine the various requirements discussed so far. For example, AND and OR requirements could be mixed: the student must pass both A *and* either B *or* C. In this case, we will group them using parentheses: A, (B + C). Use parentheses to group any ORs, otherwise commas can be used to combine requirements. Here are a few possible arrangements:

(A,B) + C: Either A *and* B *or* C


A, (MINGRADE(B)[C-] + MINGRADE(C)[C-]): A *and* B with at least a C- *or* C with at least a C-


(A + B + MINGRADE(C)[D]) + MINGRADE(E)[C-]: Either A *or* B *or* C with at least a D *OR* E with at least a C-.


*"Junior" standing, admission to major, and similar requirements*

Some authors might elect to include specific curricular blockades into their analyses, such as requirements to be a specific level (e.g., junior standing) or gain admission to a specific major. These can be representing by adding a new course that only serves as a medium to embed the requirements in the plan of study.

For example, suppose courses G and I in our example plan of study require the student to be a senior. We can add the course *SenStand* to the list of courses and prerequisites. Note that when we add *SenStand*, we need to add its prerequisites, corequisites, and term. 

When adding these kinds of requirements into the plan of study, it's most convenient to add them in the term prior to wherever they are called as prerequisites. For example, if the course requiring "senior standing" is in term 7, it is best to put it in term 6. 

```{r}
courses <-       c("A","B","C","D","E","F","SenStand","G","H",         "I")
prerequisites <- c(" "," "," ","A","C"," "," ",       "D","F,SenStand","D,SenStand")
corequisites <-  c(" ","A"," "," "," "," "," ",       " "," ",         "H")
terms <-         c(1,   1,  1,  2,  2,  2,  2,         3,  3,           3)
example_plan_of_study_sen_standing <- create_plan_of_study(Course = courses,
                                                           Prereq = prerequisites,
                                                           Coreq = corequisites,
                                                           Term = terms)
plot_plan_of_study(example_plan_of_study_sen_standing)
```


*Other requirements*

If there are requirements beyond what is described here, such as passing a placement exam or having a specific ACT/SAT score, these can be put in a notes column on your spreadsheet.

## 1.2 Converting the notation to all ANDs
In order to plot the networks properly, we need to go back to all AND relationships for the sake of aligning with the expected inputs for the igraph functions. To do so, we can use the *simplify_requisites* function. Example usage is below:

```{r}
example_requisites <- c("(A+B),(C+D)",
                        "MINGRADE(A)[C-]+(MINGRADE(B)[D],MINGRADE(C)[D])",
                        "FROM(A,B,C)[2]"
                        )
simplify_requisites(example_requisites)
```

When the networks are plotted using the *create_plan_of_study* function, only courses listed in the plan of study will be used in the construction of the network. In general, this will work without issue. However, be cautious of cases such as when course C requires either A or B, but A and B both appear in the plan of study. In this case, the cruciality of C will be overestimated. 

## 1.3 Representing electives
There are several ways to represent electives in the plan of study. Here we will review a selection of methods that we are aware of. 

## 1.3.1 Electives as generic, standalone courses

The standard advice for dealing with electives when extracting data is to represent them as standalone courses with no connections. Note that when you add courses with the same name, the *create_plan_of_study* function will automatically rename them. For example, we can add to courses called *Elec* to the last term like so:

```{r}
courses <-       c("A","B","C","D","E","F","G","H","I","Elec","Elec")
prerequisites <- c(" "," "," ","A","C"," ","D","F","D"," ",   " ")
corequisites <-  c(" ","A"," "," "," "," ",","," ","H"," ",   " ")
terms <-         c(1,   1,  1,  2,  2,  2,  3,  3,  3,  3 ,    3)
example_plan_of_study_elec <- create_plan_of_study(Course = courses,
                                                   Prereq = prerequisites,
                                                   Coreq = corequisites,
                                                   Term = terms)
plot_plan_of_study(example_plan_of_study_elec)
```

## 1.3.2 Electives as generic, but connected courses
There are, of course, other ways to include electives in the plan of study that can more faithfully represent the curricular complexity students face. For instance, if there are specific courses that are common prerequisites for the electives, then we can incorporate those directly as we would for any other course. Consider that E and F are prerequisites for one of the electives and C is a prerequisite for the other elective. In this case, we need to differentiate the electives from one another by labeling them as *Elec 1* and *Elec 2*. We would represent this like so:

```{r}
courses <-       c("A","B","C","D","E","F","G","H","I","Elec 1","Elec 2")
prerequisites <- c(" "," "," ","A","C"," ","D","F","D","E,F", "C")
corequisites <-  c(" ","A"," "," "," "," ",","," ","H"," ",   " ")
terms <-         c(1,   1,  1,  2,  2,  2,  3,  3,  3,  3 ,    3)
example_plan_of_study_elec <- create_plan_of_study(Course = courses,
                                                   Prereq = prerequisites,
                                                   Coreq = corequisites,
                                                   Term = terms)
plot_plan_of_study(example_plan_of_study_elec)
```

## 1.3.3 Customizing pathways with frequently taken electives
Instead of making the electives generic courses, you can customize the plan of study by incorporating the actual courses student frequently take (such as by reviewing student course-taking data or speaking with advisors). This is most easily accomplished by developing a *base* plan of study, like what is described in the previous examples of handling electives, then specific pathways can be constructed by replacing the elective placeholders with the common elective courses. From there, you can calculate the average of the different pathways for an overall score, if desired.

# 2. Conducting simple curricular analytics
Once you have your plan of study object, you can immediately start performing
calculations. The measures in Curricular Analytics and related literature can be
put into two categories, the *course level* and the *curriculum level*. Course
level measures can be used as a finer-grained analysis that looks "locally" at
a course or set of courses. On the other hand, curriculum level measures are
broader summaries that can be used to compare different programs to one another.

We will start with the course level measurements. Heileman et al. (2018) present 
two key metrics that define what is called the *cruciality* of a course.

*Cruciality*: A measure of how important a course is in the curriculum. Higher
values suggest the course is likely a bottleneck to student progress.

These two metrics are the *blocking factor* and the *delay factor*.

## 2.1 Blocking Factor
One intrinsic measurement that we can take to understand the cruciality of 
a course is to see how many courses it is a direct or indirect prerequisite 
for. This is the premise of the *blocking factor*.

*Blocking factor*: The number of courses inaccessible to a student if the 
given course is failed.

In the package, we can use the *blocking_factor* function to calculate this
quantity for any course. For example, we can calculate the blocking factor 
of course A. 

```{r}
blocking_factor(example_plan_of_study,"A")
```

In this case, the blocking factor is 4. Note that the blocking factor is 
including any corequisites that point from the course to a different course. 
If you would not like to include the corequisites, you can add the optional
argument *include_coreqs* and set it to FALSE.

```{r}
blocking_factor(example_plan_of_study,"A", include_coreqs = FALSE)
```

## 2.2 Delay Factor
The other measurement that can help us characterize a course's cruciality is 
examines how embedded the course is in the prerequisite structure. So, if 
a course belongs to a long prerequisite chain, we would believe this course
is more important than one that is connected to fewer, or maybe no, other courses.

*Delay Factor*: The length of the longest prerequisite chain to which the course
belongs. 

We use the *delay_factor* function in the same fashion as the *blocking factor*
function. Let's try course A.

```{r}
delay_factor(example_plan_of_study,"A")
```

In this case, course A belongs to two prerequisite chains of length 3, which 
are also the longest. Therefore, the delay factor is 3. Just like the blocking
factor, corequisites are included in the calculation. If you would like to 
omit them from the calculation, you would handle it the same way as the 
blocking factor.

```{r}
delay_factor(example_plan_of_study,"A",include_coreqs = FALSE)
```

## 2.3 Cruciality
Given the blocking and delay factors, we can calculate the cruciality of a 
course by adding its blocking factor and delay factor together. 

```{r}
blocking_factor(example_plan_of_study,"A")+delay_factor(example_plan_of_study,"A")
```

Alternatively, we can use the *cruciality* function, which performs the 
addition by itself.

```{r}
cruciality(example_plan_of_study,"A")
cruciality(example_plan_of_study,"A") == blocking_factor(example_plan_of_study,"A")+delay_factor(example_plan_of_study,"A")
```

Just like the blocking and delay factors, we can omit the corequisite relationships by changing the *include_coreqs* input to *FALSE*.

```{r}
cruciality(example_plan_of_study,"A", include_coreqs = FALSE)
```

## 2.4 Structural Complexity
If you would like to calculate a global measure of the plan of study's complexity, you can use the *structural complexity* function. The structural complexity is simply the sum of each individual course's cruciality. The only input you need to provide is the plan of study you'd like to calculate the complexity of. The output of the function is a table displaying the blocking and delay factors for each course, including the crucialities. 

```{r}
example_structural_complexity <- structural_complexity(example_plan_of_study)
#The individual outputs can be selected like so...
example_structural_complexity$`Course Crucialities`
```

The overall structural complexity can be fetched using the following command

```{r}
example_structural_complexity$`Overall Structural Complexity`
```

Sometimes researchers might be interested in exploring the impact of where courses are placed in a program. This idea was introduced in DeRocchis et al. (2021), where we add weights to the individual crucialities based on the term the courses appear within. This functionality can be accessed by using the *term_weighted* input, which is *FALSE* by default. 

```{r}
example_structural_complexity <- structural_complexity(example_plan_of_study, term_weighted = TRUE)
#The individual outputs can be selected like so...
example_structural_complexity$`Course Crucialities`
```

While we could calculate the overall structural complexity with weighted terms, the information we gain is minimal. The unweighted and weighted versions of structual complexity are almost perfectly linearly correlated. Therefore, it is advised to explore the weighted crucialities instead and ignore the aggregate score.

## 2.4.1 Structural complexity and the quarter system
The structural complexity values increase as the number of terms increases, making comparisons between plans harder when the number of terms are significantly different. This is most pronounced when comparing programs on the semester system and those on the quarter system. Because quarter systems have three additional terms, the structural complexities for these plans of study tend to be artificially higher. One way to adjust the structural complexities is to use the adjustment made for credit hours to convert between quarters and semesters, which involves dividing the number of credits by 1.5. In the same vein, we'll divide the structural complexity by 1.5.

$\alpha_{\text{semesters}} = \frac{\alpha_{\text{quarters}}}{1.5}$

We can use the argument, *quarters*, in the structural complexity function that is *FALSE* by default by changing it to *TRUE*.

```{r}
example_structural_complexity <- structural_complexity(example_plan_of_study, quarters = TRUE)
example_structural_complexity$`Course Crucialities`
example_structural_complexity$`Overall Structural Complexity`
```

# 2.5 Getting a "scorecard" for complexity values
To simplify the process of generating tables that describe plan-of-study complexity, or compiling complexity metrics across multiple programs, you can use the *generate_curricular_complexity_scorecard* function. The function generates a list containing both course-level and curriculum-level complexity metrics for a given plan of study. You can think of the tables as a *scorecard* of sorts for the program.

Note that some of the metrics presented in these tables have not been described previously. Full descriptions of these metrics can be found in Section 3. The usage of *generate_curricular_complexity_scorecard* is as follows:

```{r}
scorecard <- generate_curricular_complexity_scorecard(example_plan_of_study)
```

You can access the course-level and curriculum-level metrics like so...

```{r}
scorecard$CourseLevel
scorecard$CurriculumLevel
```

By default, corequisites are included in the calculations. If you would like to exclude them for your application, set *include_coreqs* to `FALSE`.

```{r}
scorecard <- generate_curricular_complexity_scorecard(example_plan_of_study, include_coreqs = FALSE)
scorecard$CourseLevel
scorecard$CurriculumLevel
```

# 3. Digging deeper into a plan of study
More often than not, we want to explore the plan of study more thoroughly than the general Curricular Analytics metrics. For example, there may be cases where we want to take a slice of the program to see how specific curricular design patterns look, such as the Calculus sequence or introductory mechanics sequence (i.e., Statics, Dynamics, and Strength of Materials). We have included this functionality into the package.

## 3.1 Extracting course sequences
Suppose we wanted all of the courses related to a specific course in the program, let's focus on A. We can extract the network of courses that have some direct or indirect relationship with A using the *subcomplexity_graph* function. 

```{r}
courses_related_to_A <- subcomplexity_graph(example_plan_of_study, "A")
plot_plan_of_study(courses_related_to_A)
```

From here, we can use any functions that take in the plan of study networks as an input and calculate whatever we'd please. For instance, we can run the *structural complexity* function on this subset of courses. 

```{r}
example_structural_complexity_for_subgraph <- structural_complexity(courses_related_to_A)
#The individual outputs can be selected like so...
example_structural_complexity_for_subgraph$`Course Crucialities`
```

## 3.2 Unbundling layers of requirements
If you are not necessarily interested in specific courses and would like to explore how different design patterns are embedded within a program, we can use a technique called *core collapse*, which has an aptly named function that performs this operation

The *core collapse* procedure builds on the idea of *k-cores* in graph theory. A *k-core* refers to a graph that contains vertices with degrees of at least k - usually discussed as a subgraph of a larger network. In other words, a k-core in this context would refer to the set of courses with at least k pre- or corequisites attached to them.   

The idea of the *core collapse* procedure involves gradually removing courses with more and more connections until every course is eliminated using the network's k-cores. We start with the 1-core, where each course is connected to at least one other course through a prerequisite relationship. At each iteration, the proportion of courses removed relative to the original total number of vertices is recorded, forming a sequence. So, in the next step, we remove the courses that don't belong to the 1-core and find those that belong to the 2-core. We perform the same operation, remove the courses that don't belong to the 2-core, record the proportion of courses that were removed, and continue until no courses are left. A sequence that decreases quickly to zero typically indicates that the network is generally uniform in terms of the number of courses with different numbers of prerequisites. A sequence with more erratic values that does not settle to zero smoothly would imply more dense sets of prerequisites.

To call the function, we just need to input the plan of study we want to decompose.

```{r}
example_core_collapse <- core_collapse(example_plan_of_study)
```

Then, we can fetch the sequence and the associated network at each step of the process. For more complex programs, each slice (i.e., each k-core) will show another layer of requirements than could make it simpler to see how courses are related to one another. 

The first output we can examine is the *core collapse sequence*

```{r}
example_core_collapse$sequence
```

The k-cores that are formed at each step can be pulled out and plotted individually just like the subcomplexity graphs. This procedure treats the plan of study like an onion, where we can progressively remove layers until we reach the middle.

```{r}
kcores <- example_core_collapse$kcores
plot_plan_of_study(kcores[[1]])
plot_plan_of_study(kcores[[2]])
plot_plan_of_study(kcores[[3]])
```

## 3.3 Other course-level metrics 
Other metrics have been proposed in the literature that provide different perspectives on the impact of specific course on student progress. This section will overview a selection of them that are available in the package

### 3.3.1 Deferment factor
The *deferment factor* is one of the few metrics available that uses the term information for the course. If you look back at the calculations for the typical metrics included in Curricular Analytics, the *blocking factor* and the *delay factor*, neither depend on how courses are organized term-wise. This factor fetches the number of terms a student would need to fail a course before extending their time to degree, $k$. 

$D(c_i) = \frac{1}{k + 1}$

In fact, for prerequisite chains with no gaps in terms, this factor can be calculated using the delay factor, *when ignoring corequisite relationships* (denoted by $d'(c_i)$) like so:

$D(c_i) = \frac{1}{max(0,t_e-t(c_i)-(d'(c_i)-t(c_i)+1)+1)+1}$

If a course cannot be failed without extending the student's time to degree, then the deferment factor will be 1. Smaller values of the deferment factor suggest more flexible courses. For example, course A is embedded in a three-course long prerequisite chain, which leads to a deferment factor of 1. 

The inputs of the *deferment_factor* function include the plan of study, the course to calculate the deferment factor of, and the expected completion term.

```{r}
deferment_factor(example_plan_of_study,"A",3)
```

On the other hand, course B is a corequisite for A, which (in general) is a less strict relationship. Therefore, we can treat it independent of A. Since it isn't connected to other courses, its deferment factor is the minimum possible. 

$min(D(c_i)) = \frac{1}{t_e}$

In this case, the minimum is $1/3$.

```{r}
deferment_factor(example_plan_of_study,"B",3)
```

### 3.3.2 Bottleneck courses
In highly sequenced curricular, like those found in STEM, there is often a concept of a *gateway*, *weed-out*, *gatekeeper*, or *bottleneck course*. These courses tend to be difficult, foundational courses that present the most significant barriers to student progress. In Curricular Analytics, a course with a high cruciality tends to identify such *bottleneck course*. However, what if you wanted to define what a bottleneck course means to you? This is accomplished using the *find_bottlenecks* function.

The *find_bottlenecks* function has five inputs, one of which is optional. Given an inputted plan of study, the user specifies the minimum number of prerequisites, the minimum number of courses the course serves as a prerequisite for (i.e., *"postreqs"*), and the minimum number of total connections. You can also specify whether you'd like to include corequisites in the calculation; it is *TRUE* by default. Suggested values from the original paper (Wigdahl et al., 2013) would suggest typical usage is  find_bottleneck(),3,3,5), which are provided by default. 

```{r}
find_bottlenecks(example_plan_of_study,min_prereq = 3, min_postreq = 3, min_connections = 5,include_coreqs = TRUE)
```

Note the function also works without specifying the other arguments

```{r}
find_bottlenecks(example_plan_of_study)
```

Since the network is a small, we don't have any bottlenecks as traditionally defined, so we can adjust our parameters however we'd like, for example...

```{r}
find_bottlenecks(example_plan_of_study,min_prereq = 2, min_postreq = 2, min_connections = 3,include_coreqs = TRUE)
```

In this case, A, D, and I are sorted out as bottlenecks. 

Note that min_connections >= min_prereq + min_postreq - 2. If this is violated, a warning is provided and corrected to the suggested minimum value of min_prereq + min_postreq - 2. 

```{r}
find_bottlenecks(example_plan_of_study,min_prereq = 2, min_postreq = 2, min_connections = 1,include_coreqs = TRUE)
```

# 3.3.3 Reachability Factor
If you are interested in calculating the number of courses that a student needs to pass in order to enroll in a later course, you are looking for a metric that is the opposite of the blocking factor called the *reachability factor*.  The *reachability_factor* function takes the same inputs as the blocking factor, the plan of study and the course you want to find the reachability factor for. 

```{r}
reachability_factor(example_plan_of_study,"G")
```

Like the delay and blocking factor, there is an optional argument to include the corequisites. If you'd like to exclude them, you will set the *include_coreqs* argument to be *FALSE*.

```{r}
reachability_factor(example_plan_of_study,"G", include_coreqs = FALSE)
```

#3.4 Other curriculum level metrics
Unlike course-level metrics, there are much fewer structural metrics at the curriculum level. This section provides a few examples of the metrics available in the package. 

## 3.4.1 Curriculum rigidity
A simpler metric to quantify how complex a curriculum is would be to use what's called the *curriculum rigidity*. This metric borrows the *beta index* from graph theory, which is calculated as the number of edges (i.e., pre and corequisites) divided by the number of vertices (i.e., courses). A value larger than 1 denotes a more complex network; whereas, a value below 1 would indicate a sparser network. 

The function to run this analysis is *curriculum_rigidity*, with only the plan of study as the input.

```{r}
curriculum_rigidity(example_plan_of_study)
```

## 3.4.2 Topic cruciality
Topic cruciality describes how much a particular topic area contributes to the structural complexity of a plan of study. It is calculated by identifying all courses in the plan of study that share a specified course-code stem (e.g., MATH, MAE, or CS) and summing their individual course cruciality values.

The idea is inspired by the concept of math cruciality introduced by Olivia Ryan, which examines the role that mathematics courses play in the complexity of engineering curricula. Topic cruciality extends this idea beyond mathematics so that the same approach can be used to examine any collection of courses that can be identified by a common course-code stem.

For example, consider a mechanical engineering plan of study containing the following courses:

MATH 1210 — Cruciality = 33
MATH 1220 — Cruciality = 28
MATH 2210 — Cruciality = 16
MAE 2160 — Cruciality = 7
MAE 2300 — Cruciality = 14

If we calculate topic cruciality for MATH, the function identifies the three mathematics courses and sums their crucialities:

33 + 28 + 16 = 77

Thus, the MATH topic cruciality is 77 for this plan of study.

Let's use a different example with course codes to show how this function works.

```{r}
courses <-       c("MATH 1010", "PHYS 1010", "ENGR 1010",
                   "CS 1010", "MATH 1020", "ENGR 1020",
                   "ME 2010", "ENGR 2010", "ME 2020")

prerequisites <- c(" ", " ", " ",
                   " ", "MATH 1010", "ENGR 1010",
                   "CS 1010", "ENGR 1020", "ME 2010")

corequisites <-  c(" ", " ", " ",
                   " ", " ", " ",
                   " ", " ", "ENGR 2010")

terms <-         c(1, 1, 1,
                   1, 2, 2,
                   2, 3, 3)

example_plan_of_study_course_codes <- create_plan_of_study(Course = courses,
                                              Prereq = prerequisites,
                                              Coreq = corequisites,
                                              Term = terms)
plot_plan_of_study(example_plan_of_study_course_codes)
```

The usage is as follows. Note that corequisites can be excluded, as in other functions, using the `include_coreqs` argument.

Let's find the topic cruciality for the ENGR courses in our example plan of study. The resulting topic cruciality is 18.

```{r}
topic_cruciality(
  example_plan_of_study_course_codes,
  "ENGR",
  include_coreqs = TRUE
)
```

We can verify this calculation by examining the structural complexity of the plan of study and the cruciality values for the ENGR courses. In this example, the ENGR courses have cruciality values of 7, 2, and 9, which sum to 18.

```{r}
structural_complexity(example_plan_of_study_course_codes)[[1]][c(3, 6, 8), ]
```

# 4. Transfer-Sensitive Metrics
If you are interested in exploring what curricular complexity looks like for transfer students, metrics that quantify issues felt particularly by the transfer student population are available. These include the *transfer delay factor*, *complexity explained*, *inflexibility factor*, and *credit loss*.The first factor that doesn't require any additional information beyond what is needed for the metrics discussed before is the *transfer delay factor* and *complexity explained*

# 4.1 Transfer Delay Factor
When designing a transfer pathway, there might be cases where it is simply not feasible to design the program of study that enables the student to complete their requirements in the expected time to degree - usually eight semesters. The original metrics do not punish courses that extend students' time to degree. Therefore, the transfer delay factor focuses on the courses that are extending the student's time to degree by summing the delay factors of the courses in the terms beyond the user-specified intended finishing term.

For example, assume we expect to finish the example plan of study in two terms instead of three. This means there are three courses beyond the expected time to degree. We can calculate the associated *transfer delay factor* associated with these courses like so:

```{r}
transfer_delay_factor(example_plan_of_study,2)
```

If you are interested in the network of courses associated with the transfer delay factor, you can use the *transfer_excess_courses* function. It has the same inputs as the *transfer_delay_factor* function. 

```{r}
courses_extending_time <- transfer_excess_courses(example_plan_of_study,2)
plot_plan_of_study(courses_extending_time)
```

We can calculate the average sequencing causing the delays using the *average_sequencing* function as well. This function has two uses. With a single input, the plan of study object, the average length of the prerequisite chains in the curriculum will be reported. When we add the expected time to degree as the second argument, then we get the average length of the prerequisite chains for the courses extending the time to degree.

```{r}
#Only supplying the plan of study object will return the average length of the prerequisite chains for the entire plan of study.
average_sequencing(example_plan_of_study)
#Adding the expected time to degree will only calculated the average for the courses extending the time to degree.
average_sequencing(example_plan_of_study, expected_time_to_degree = 2)
```

# 4.2 Explained Complexity
Another way to look at this situation is to consider what proportion of the overall structural complexity is attributable to the courses extending the students' time to degree. We can calculate this using the *explained_complexity* function. The inputs are the exact same as the *transfer_delay_factor* function. As an output, the *explained_complexity* function will give the structural complexity and the *transfer subcomplexity*, which is the structural complexity of the subgraph formed by the courses that are connected to the courses extending the time to degree. The ratio of the transfer subcomplexity to the overall structural complexity is the *explained complexity*.

```{r}
explained_complexity(example_plan_of_study,2)
```

# 4.3 Inflexibility Factor
The original conceptualization of Curricular Analytics assumes that courses are available at all times, which isn't necessary realistic for many programs. This issue is particular salient for transfer students, where students can enter at different times and the availability of course can also impact their progression. 

The timing of courses that is currently supported uses semesters. The possible designations are "Fall", "Spring","Alt Fall", and "Alt Spring". These are included in the plan of study object by adding the timing information in the following format. Note that the timing needs to be specified when creating the plan of study object.

```{r}
courses <-       c("A","B","C","D","E","F","G","H","I")
prerequisites <- c(" "," "," ","A","C"," ","D","F","D")
corequisites <-  c(" ","A"," "," "," "," "," "," ","H")
terms <- c(1,1,1,2,2,2,3,3,3)

#Now we'll incorporate the timing here:
timing <- c("Fall",NA,NA,"Alt Spring",NA,NA,"Alt Fall",NA,"Spring")

example_plan_of_study <- create_plan_of_study(Course = courses,
                                              Prereq = prerequisites,
                                              Coreq = corequisites,
                                              Term = terms,
                                              Timing = timing)
```

Once we have incorporated the timing, we can calculate the *inflexibility factor*. The inflexibility factor is calculated for courses that have limited offerings. The function works by taking the course that is offered in specific terms and moves it to the next available term it can be taken. We then determine how many terms the student's time to degree is extended. After which, we sum the original term the course was offered, the number of terms it shifted, and the number of additional terms added to the student's time to degree. This value is a weight that multiply with the course's delay factor. 

```{r}
inflexibility_factor_result <- inflexibility_factor(example_plan_of_study,2)
inflexibility_factor_result$`Inflexibility Factors`
inflexibility_factor_result$Total
```

The function, *inflexibility_factor* will output two things: (1) a table of the individual inflexibility factors and (2) a total inflexibility factor summing them.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/delay_factor.R
\name{delay_factor}
\alias{delay_factor}
\title{Calculates the delay factor of a course}
\usage{
delay_factor(plan_of_study, course, include_coreqs = TRUE)
}
\arguments{
\item{plan_of_study}{igraph object - An igraph object created using the create_plan_of_study function}

\item{course}{Numeric (vertex id) or String - The course to calculate the delay factor of}

\item{include_coreqs}{Logical - Calculates the delay factor using corequisites, default value is TRUE}
}
\value{
Numeric - the delay factor
}
\description{
This function takes in a plan of study and a course, then finds that course's delay factor.
The output is the longest path of prerequisites through the given course.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simplify_requisites.R
\name{simplify_requisites}
\alias{simplify_requisites}
\title{Convert requisites to original notation}
\usage{
simplify_requisites(requisites)
}
\arguments{
\item{requisites}{vector object - A vector describing the pre and corequisites (as strings)}
}
\value{
vector object -  A simplified vector describing the pre and corequisites (as strings)
}
\description{
This function takes in either the pre or corequisites of a plan of study as a vector, then
removes any additional information like OR relationships and minimum grades such that the
network can be analyzed using the traditional functions.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cruciality.R
\name{cruciality}
\alias{cruciality}
\title{Calculates the cruciality of a course}
\usage{
cruciality(plan_of_study, course, include_coreqs = TRUE)
}
\arguments{
\item{plan_of_study}{igraph object - An igraph object created using the create_plan_of_study function}

\item{course}{Numeric (vertex id) or String - The course to calculate the cruciality of}

\item{include_coreqs}{logical - Indicates whether corequisites should be included in the calculation}
}
\value{
Numeric - the course's cruciality
}
\description{
This function takes in a plan of study and a course, then finds that course's cruciality.
The value is the sum of the blocking and delay factors of the course
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/curriculum_rigidity.R
\name{curriculum_rigidity}
\alias{curriculum_rigidity}
\title{Calculates the curriculum rigidity}
\usage{
curriculum_rigidity(plan_of_study)
}
\arguments{
\item{plan_of_study}{igraph object - An igraph object created using the create_plan_of_study function}
}
\value{
Numeric - the curriculum rigidity
}
\description{
This function takes in a plan of study and then finds the curriculum's rigidity.
The rigidity is the beta index of the graph, which is the number of prerequisites
divided by the number of courses
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transfer_excess_courses.R
\name{transfer_excess_courses}
\alias{transfer_excess_courses}
\title{Finds the subcomplexity graph of courses beyond expected time to degree}
\usage{
transfer_excess_courses(
  plan_of_study,
  expected_time_to_degree,
  include_coreqs = TRUE
)
}
\arguments{
\item{plan_of_study}{igraph object - An igraph object created using the create_plan_of_study function}

\item{expected_time_to_degree}{Numeric - The term where students are expected to finish (often 8)}

\item{include_coreqs}{Logical - Calculates the delay factor using corequisites, default value is TRUE}
}
\value{
igraph object - the subcomplexity graph
}
\description{
This function takes in a plan of study and the expected time to degree, then outputs a subcomplexity
graph that contains all of the courses beyond the time to degree and their prerequisites.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/blocking_factor.R
\name{blocking_factor}
\alias{blocking_factor}
\title{Calculates the blocking factor of a course}
\usage{
blocking_factor(plan_of_study, course, include_coreqs = TRUE)
}
\arguments{
\item{plan_of_study}{igraph object - An igraph object created using the create_plan_of_study function}

\item{course}{Numeric (vertex id) or String - The course to calculate the blocking factor of}

\item{include_coreqs}{logical - Indicates whether corequisites should be included in the calculation}
}
\value{
Numeric - the blocking factor
}
\description{
This function takes in a plan of study and a course, then finds that course's blocking factor.
The value is the number of courses 'blocked' by failing the given course.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/admissibility_test.R
\name{admissibility_test}
\alias{admissibility_test}
\title{Automatically check for data entry issues}
\usage{
admissibility_test(plan_of_study)
}
\arguments{
\item{plan_of_study}{igraph object - An igraph object created using the create_plan_of_study function}
}
\value{
List of errors to correct for cycles, prereqs, and coreqs
}
\description{
This function takes in a plan of study, then checks for potential data entry issues.
It will detect issues in formatting with the csv (such as notes creating empty rows), if there
are cycles in the network, and if pre- and corequisites are appropriately defined.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/topic_cruciality.R
\name{topic_cruciality}
\alias{topic_cruciality}
\title{Calculate Topic Cruciality}
\usage{
topic_cruciality(plan_of_study, course_code_stem, include_coreqs = TRUE)
}
\arguments{
\item{plan_of_study}{A plan of study for which course crucialities can be
calculated.}

\item{course_code_stem}{A character string identifying the course-code stem
used to define the topic area. For example, `"MATH"` identifies all
mathematics courses with the `"MATH"` course-code stem.}

\item{include_coreqs}{A logical value indicating whether corequisite
relationships should be included when calculating course crucialities.
Defaults to TRUE.}
}
\value{
The topic cruciality, calculated as the sum of the cruciality values
  for courses in the plan of study with the specified course-code stem.
}
\description{
Calculates the cruciality attributable to a particular course-code stem
within a plan of study. Topic cruciality is calculated as the sum of the
cruciality values for all courses in the plan of study whose course code
matches the specified course-code stem.
}
\details{
This measure is generalized from the concept of math cruciality described
by Ryan (2026), which examines the contribution of required mathematics
courses to curriculum complexity. Rather than being restricted to
mathematics, this function can be used to calculate the cruciality of any
collection of courses that can be identified by a common course-code stem.
}
\references{
Ryan, O. J. (2026). *The Role of Math Courses in Engineering Education:
Examining How Math Courses Shape First-Year Student Transition, Curriculum
Complexity, and Time-to-Degree* (Doctoral dissertation, Virginia Tech).
https://vtechworks.lib.vt.edu/items/4ddd7b33-8700-45d4-988d-2111a2970389
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/explained_complexity.R
\name{explained_complexity}
\alias{explained_complexity}
\title{Calculates the explained complexity of courses extending time to degree}
\usage{
explained_complexity(
  plan_of_study,
  expected_time_to_degree,
  term_weighted = FALSE
)
}
\arguments{
\item{plan_of_study}{igraph object - An igraph object created using the create_plan_of_study function}

\item{expected_time_to_degree}{Numeric - The term where students are expected to finish (often 8)}

\item{term_weighted}{logical - TRUE if crucialities should be term-weighted}
}
\value{
Numeric - the explained complexity
}
\description{
This function takes in the subcomplexity graph from the transfer excess courses function, then finds the transfer delay
factor. The output is the proportion of complexity explained by courses extending time to degree.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_plan_of_study.R
\name{plot_plan_of_study}
\alias{plot_plan_of_study}
\title{Plots the plan of study with courses ordered by term}
\usage{
plot_plan_of_study(plan_of_study)
}
\arguments{
\item{plan_of_study}{igraph object - An igraph object created using the create_plan_of_study function}
}
\value{
Plots the plan of study in the 'plot' window
}
\description{
This function takes in a plan of study and plots it in the 'plot' window.
The courses are ordered horizontally by term and vertically by the outdegree
(i.e., number of prereqs) of the vertices in that column/term. The shading of
the nodes corresponds to the cruciality of the course. A darker blue indicates
higher cruciality while white indicates lower cruciality.
}
\details{
Note that there can be some overlap where a course is covering a path for a prereq,
which may make is seem like a course is a prereq for some other course when it is
in fact the course in a previous semester.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/find_bottlenecks.R
\name{find_bottlenecks}
\alias{find_bottlenecks}
\title{Finds the bottlenecks in the plan of study based on prerequisite relationships}
\usage{
find_bottlenecks(
  plan_of_study,
  min_prereq = 3,
  min_postreq = 3,
  min_connections = 5,
  include_coreqs = TRUE
)
}
\arguments{
\item{plan_of_study}{igraph object - An igraph object created using the create_plan_of_study function}

\item{min_prereq}{numeric - minimum number of prerequisites defining a bottleneck}

\item{min_postreq}{numeric - minimum number of courses the given course is a prerequisite for}

\item{min_connections}{numeric - minimum total of the number of prerequisites}

\item{include_coreqs}{boolean - default is TRUE, treats corequisites as prerequisites
and the number of courses the given course is a prerequisite for}
}
\value{
atomic vector - list of courses meeting at least one condition of the three parameters
}
\description{
This function takes in a plan of study and three parameters. In this case, we
choose min_prereq,min_postreq, and min_connections. The value of min_prereq is the minimum number of prerequisites defining
a bottleneck (in the user's perspective), whereas min_postreq is the minimum number of courses
the given course is a prerequisite for. Finally, min_connections is the minimum total of the number of prerequisites
and the number of courses the given course is a prerequisite for. A course is a bottleneck if it meets
at least one of the parameters
}
\details{
Suggested values for typical usage is find_bottleneck(x,3,3,5), which are #' provided by default.
Note that min_connections >= min_prereq + min_postreq - 2. If this is violated, a warning is
provided and corrected to the suggested minimum value of min_prereq + min_postreq - 2.

The output is an atomic vector of possible bottlenecks based on the user-defined parameters.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generate_curricular_complexity_scorecard.R
\name{generate_curricular_complexity_scorecard}
\alias{generate_curricular_complexity_scorecard}
\title{Generate a scorecard of curricular complexity metrics}
\usage{
generate_curricular_complexity_scorecard(plan_of_study, include_coreqs = TRUE)
}
\arguments{
\item{plan_of_study}{An igraph object representing a plan of study,
created using the \code{\link{create_plan_of_study}} function.}

\item{include_coreqs}{A logical value indicating whether corequisite
courses should be included when calculating course-level metrics and
structural complexity.}
}
\value{
A list containing two elements:
  \describe{
    \item{CourseLevel}{A data frame containing the course-level metrics
      \code{Course}, \code{Blocking}, \code{Reachability}, \code{Delay},
      \code{Cruciality}, \code{Deferment}, and \code{Bottleneck}. An
      asterisk in the \code{Bottleneck} column indicates that the course
      was identified as a bottleneck.}
    \item{CurriculumLevel}{A named vector containing the curriculum-level
      metrics \code{StructuralComplexity}, \code{CurricularRigidity}, and
      \code{TotalBottlenecks}.}
  }
}
\description{
This function calculates course-level and curriculum-level curricular
complexity metrics for a plan of study. Course-level metrics include
blocking, reachability, delay, cruciality, deferment, and bottleneck
status. Curriculum-level metrics include structural complexity,
curricular rigidity, and the total number of bottleneck courses.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transfer_delay_factor.R
\name{transfer_delay_factor}
\alias{transfer_delay_factor}
\title{Calculates the transfer delay factor of a course}
\usage{
transfer_delay_factor(plan_of_study, expected_time_to_degree)
}
\arguments{
\item{plan_of_study}{igraph object - An igraph object created using the create_plan_of_study function}

\item{expected_time_to_degree}{Numeric - The term where students are expected to finish (often 8)}
}
\value{
Numeric - the transfer delay factor
}
\description{
This function takes in the subcomplexity graph from the transfer excess courses function, then finds the transfer delay
factor. The output is the sum of the longest paths of prerequisites through courses related to those beyond the
expected time to degree.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/student_mobility_turbulence.R
\name{student_mobility_turbulence}
\alias{student_mobility_turbulence}
\title{Calculates the student mobility turbulence for a program}
\usage{
student_mobility_turbulence(
  number_withrawn,
  number_changed_major,
  total_number_of_students,
  withdrawn_coefficient = 1,
  changed_major_coefficient = 0.5
)
}
\arguments{
\item{number_withrawn}{numeric - the total number of students who dropped out of a program in a given unit}

\item{number_changed_major}{numeric - the total number of students who changed majors in a given unit}

\item{total_number_of_students}{numeric - the total number of students in a given unit starting at a specific time}

\item{withdrawn_coefficient}{numeric - a coefficient weighting the number of students who dropped out}

\item{changed_major_coefficient}{numeric - a coefficient weighting the number of students who changed majors out}
}
\value{
numeric -  The student mobility turbulence
}
\description{
This metric captures the volatility in student progression by analyzing
the withdraws and major changes, which can indicate structural barriers
or inefficiencies in the curriculum. This is most useful to apply to a combination
of programs or a unit, like a department or college. There are two coefficients,
withdrawn and changed major that can be used to prioritize either of the two causes
for turbulence. They are set to 1 and 0.5 by default, respectively.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/core_collapse.R
\name{core_collapse}
\alias{core_collapse}
\title{Calculates the core collapse sequence for a plan of study}
\usage{
core_collapse(plan_of_study)
}
\arguments{
\item{plan_of_study}{igraph object - An igraph object created using the create_plan_of_study function}
}
\value{
List of two items: (1) sequence - the core collapse sequence, (2) the associated network for each entry
}
\description{
This function takes in a plan of study network and constructs the "core collapse sequence."
The core collapse sequence progressively removes courses from the plan of study with increasing
prereq counts and calculates the proportion of courses deleted at each step. The process stops
when all of the vertices have been removed. A sequence that decreases quickly to zero typically
indicates that the network is generally uniform with its prereqs. A sequence with more erratic
values that does not settle to zero smoothly would imply more dense sets of prereqs.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/inflexibility_factor.R
\name{inflexibility_factor}
\alias{inflexibility_factor}
\title{Calculates inflexibility factor of a plan of study}
\usage{
inflexibility_factor(plan_of_study, time_to_degree)
}
\arguments{
\item{plan_of_study}{igraph object - An igraph object created using the create_plan_of_study function}

\item{time_to_degree}{numeric - expected time to degree, often 8}
}
\value{
list of (1) a dataframe of inflexibility factors and (2) a total inflexibility factor
}
\description{
Calculates the inflexibility factor for courses that have specific offering times extending chains beyond the
expected time to degree.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/subcomplexity_graph.R
\name{subcomplexity_graph}
\alias{subcomplexity_graph}
\title{Creates a subcomplexity graph for a course}
\usage{
subcomplexity_graph(plan_of_study, course)
}
\arguments{
\item{plan_of_study}{igraph object - An igraph object created using the create_plan_of_study function}

\item{course}{Numeric (vertex id) or String - The course to find the subcomplexity graph of}
}
\value{
igraph object representing the course's subcomplexity graph.
}
\description{
This function takes in a plan of study and course, then constructs the subcomplexity graph for the course.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/average_sequencing.R
\name{average_sequencing}
\alias{average_sequencing}
\title{Calculates the average sequencing in a program}
\usage{
average_sequencing(plan_of_study, expected_time_to_degree = NULL)
}
\arguments{
\item{plan_of_study}{igraph object - An igraph object created using the create_plan_of_study function}

\item{expected_time_to_degree}{Numeric - The term where students are expected to finish (often 8)}
}
\value{
Numeric - the average sequencing in the program
}
\description{
This function calculates the average sequencing in the program using the
delay factors of the courses. The second argument, expected_time_to_degree
is optional. If it is not NULL, the average sequencing will be for courses
extending the student's time to degree.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/structural_complexity.R
\name{structural_complexity}
\alias{structural_complexity}
\title{Calculates structural complexity of a plan of study}
\usage{
structural_complexity(
  plan_of_study,
  term_weighted = FALSE,
  include_coreqs = TRUE,
  quarters = FALSE
)
}
\arguments{
\item{plan_of_study}{igraph object - An igraph object created using the create_plan_of_study function}

\item{term_weighted}{logical - TRUE if crucialities should be term-weighted}

\item{include_coreqs}{logical - TRUE if coreqs should be included when calculating blocking and delay factor}

\item{quarters}{logical - TRUE if the plan of study uses quarters instead of semesters}
}
\value{
list of (1) a dataframe of course crucialities, delay factors, and blocking factors; (2) a numeric value
of structural complexity
}
\description{
This function takes in a plan of study, then finds the plan of study's structural complexity.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/find_number_of_free_terms.R
\name{find_number_of_free_terms}
\alias{find_number_of_free_terms}
\title{Finds the number of terms a course can move to}
\usage{
find_number_of_free_terms(
  plan_of_study,
  course,
  expected_time_to_degree,
  outbound_only
)
}
\arguments{
\item{plan_of_study}{igraph object - An igraph object created using the create_plan_of_study function}

\item{course}{Numeric (vertex id) or String - The course to find the number of free terms for}

\item{expected_time_to_degree}{Numeric - The term where students are expected to finish (often 8)}

\item{outbound_only}{logical - TRUE if the calculation should only include courses after the course (postreqs)}
}
\value{
Numeric - the number of free terms
}
\description{
This function takes in a plan of study, a course, the expected time to degree, and a
logical value indicating whether to restrict the number of free terms to those later
in the curriculum. The value is the number of free terms that the course can move to
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/deferment_factor.R
\name{deferment_factor}
\alias{deferment_factor}
\title{Calculates the deferment factor of a course}
\usage{
deferment_factor(
  plan_of_study,
  course,
  expected_time_to_degree,
  outbound_only = TRUE
)
}
\arguments{
\item{plan_of_study}{igraph object - An igraph object created using the create_plan_of_study function}

\item{course}{Numeric (vertex id) or String - The course to calculate the deferment factor of}

\item{expected_time_to_degree}{Numeric - The term where students are expected to finish (often 8)}

\item{outbound_only}{logical - TRUE (by default) if the calculation should only include courses after the course (postreqs)}
}
\value{
Numeric - the deferment factor
}
\description{
This function takes in a plan of study and a course, then finds that course's deferment factor.
The value captures the number of terms the student can fail the course before extending their time
to degree.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_plan_of_study.R
\name{create_plan_of_study}
\alias{create_plan_of_study}
\title{Create a plan of study igraph object}
\usage{
create_plan_of_study(
  Course,
  Term,
  Prereq,
  Coreq,
  Credits = NULL,
  LostCredits = NULL,
  PassRate = NULL,
  Timing = NULL,
  Institution = NULL
)
}
\arguments{
\item{Course}{atomic vector - strings for each course}

\item{Term}{a numeric atomic vector - the term  each course is offered}

\item{Prereq}{atomic vector - strings of the courses' prereqs, separated by commas}

\item{Coreq}{atomic vector - strings of the courses' coreqs, separated by commas}

\item{Credits}{numeric atomic vector - number of credits each course is worth (optional)}

\item{LostCredits}{numeric atomic vector - (for transfer students) identifies if credit for the course is not applied toward a student's degree, 1. If it is, 0. (optional)}

\item{PassRate}{numeric atomic vector - pass rates by class (optional)}

\item{Timing}{numeric atomic vector - number of times the course is offered in 2 years (optional)}

\item{Institution}{atomic vector - strings of course affiliations (CC or FY)}
}
\value{
An igraph object of the prerequisite structure
}
\description{
This function takes in a set of courses, their terms, prerequisites, and corequisites.
Optional arguments include the number of credits, pass rates, lost credits from transferring,
and the frequency of course offerings. The function creates an igraph structure of edges and nodes with the
given qualities.
}
\details{
It is recommended that the user imports the data from a csv file to
ensure the indices for each atomic vector correspond to the attributes of one course.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/find_inbound_courses.R
\name{find_inbound_courses}
\alias{find_inbound_courses}
\title{Find all possible prerequisites to a course}
\usage{
find_inbound_courses(plan_of_study, course, include_coreqs = TRUE)
}
\arguments{
\item{plan_of_study}{An igraph object created using the create_plan_of_study function}

\item{course}{The course to find all relevant prerequisites of}

\item{include_coreqs}{Logical - Calculates the delay factor using corequisites, default value is TRUE}
}
\value{
An atomic vector of vertex ids for the course's prerequisites
}
\description{
This function takes in a plan of study and a course, then finds all the courses it is related to
through its prerequisites
}
